///////////////////////////////////////////////
//              mid.js                       //
/////////////////////////////////////////////// 
//
// More than 500 bugs in less than 150 Kilobyte!
// ---------------------------------------------
// Acknowledgement:
//
// This code contains parts of other extensions such as iconifyTabs, duplicateTab
// Flowing tabs, miniT, and so one. Many thanks for their authors. 
// ---------------------
// All the bugs are mine. 
//////////////////////////////////////////////

const Cc = Components.classes;
const Ci = Components.interfaces;

midPrefBranch = Cc["@mozilla.org/preferences-service;1"].getService(Ci.nsIPrefBranch);
midPrefs  = Cc["@mozilla.org/preferences-service;1"].getService(Ci.nsIPrefService);
// findService = Cc["@mozilla.org/find/find_service;1"].getService(Ci.nsIFindService);

Components.utils.import("resource://gre/modules/Services.jsm");  
Components.utils.import("resource://gre/modules/FileUtils.jsm"); 

var mid_mud =  {
    dictionary : "default",
    olddictionary : "",
    fromDialog : false,
    forwardCounter : 0,
    backCounter : -1,
    saveInHistory : true,
    midRowCounter : -1,
    midFullScreen : false,
    midFromRestore : false,
    homepage : "about:blank",
    midNS : "http://mid.mozdev.org/dictionaries",
    MAXREOPENFILES : 5,
    FIRSTDYNAMICMENUITEM : 2, 
    fullPageZoom : 1.2,
    lineending : "\n",  
    session_name : "No name",    
 
    Start: function () { 
        // TODO : change it to simple functions 
         var mainWindow = window.QueryInterface(Components.interfaces.nsIInterfaceRequestor)
                  .getInterface(Components.interfaces.nsIWebNavigation)
                  .QueryInterface(Components.interfaces.nsIDocShellTreeItem)
                  .rootTreeItem
                  .QueryInterface(Components.interfaces.nsIInterfaceRequestor)
                  .getInterface(Components.interfaces.nsIDOMWindow);

        addEventListener("focus",     mid_mud.focusManager.checkFocusedElement, false);
        addEventListener("mousedown", mid_mud.focusManager.checkClickedElement, false);
        mainWindow.document.addEventListener("keypress",  mid_mud.focusManager.checkKeypressElement, true, true);

        this.util.dumpToConsole("Event listeners started ");
        domHelper = new domHelperObject();
        this.hideChromeForTab(); 

        if (this.util.platformIsWindows())  { this.lineending = "\r\n"; }
 
        loadFFsearchEngines();
        this.newVersions();
        this.tabManager.Init();
        this.managePreferences(); 
        this.setBrowserURL();
        // old: this.fileManager.restoreDefaultSet(); 
        // old: this.midSession.restore();            
        // new: restore from  db :;
	//if (this.util.getLocaleString("default.session.name")) this.session_name = this.util.getLocaleString("default.session.name");
	this.db.getContinueBySessionName();
        this.db.restoreSession(this.session_name);
	googTransInit(); 
    },


    hideChromeForTab : function () {
        const nsIWindowMediator = Ci.nsIWindowMediator;
        var windowMediator = Cc['@mozilla.org/appshell/window-mediator;1'].getService();
        windowMediator = windowMediator.QueryInterface(nsIWindowMediator);
        var win = windowMediator.getMostRecentWindow("navigator:browser");
        if (win) {
            mid_mud.util.dumpToConsole("tryed to hide");
            var prevFunc = win.XULBrowserWindow.hideChromeForLocation; 
            win.XULBrowserWindow.hideChromeForLocation = function(aLocation) {
                  return aLocation == "chrome://mid/content/mid.xul?tab" || prevFunc.apply(win.XULBrowserWindow, [aLocation]);
            } 
        }
    },


    unload : function () {
       // purge history
       removeEventListener("focus",     mid_mud.focusManager.checkFocusedElement,  false);
       removeEventListener("mousedown", mid_mud.focusManager.checkClickedElement,  false);
       removeEventListener("keypress",  mid_mud.focusManager.checkKeypressElement, true, true);
       mid_mud.util.dumpToConsole("Event listeners stopped ");

       //this.saveDSet();
       //this.midSession.save();
       mid_mud.db.saveSessionAs(mid_mud.session_name);
       this.branch.removeObserver("", this);
    },



    newVersions : function () {

       var midDirectory = Cc["@mozilla.org/file/directory_service;1"].getService(Ci.nsIProperties)
                 .get("ProfD", Components.interfaces.nsIFile);

       var def_wordhistory = midDirectory.clone();
       var def_dictionaries = midDirectory.clone();

       midDirectory.append("mid");
       try {
           if (!midDirectory.exists() || !midDirectory.isDirectory()) {   // if it doesn't exist, create
               midDirectory.create(Components.interfaces.nsIFile.DIRECTORY_TYPE, 0777);
           }
       } catch (e) {
               if (e.name == "NS_ERROR_FILE_ACCESS_DENIED") { 
                   mid_mud.util.localAlert("file.access.denied", " : " + midDirectory.path); 
               } else {
                   alert("i/o error: " + e.name + "-" + e.message + " Can't create directory: " + midDirectory.path ); // TODO :  localize
               }
               return false;
       }
      
       def_wordhistory.append("everyday.txt");                 // old file under ProfD
       def_dictionaries.append("mid_default.dis");             // old file under ProfD  
       if (!def_wordhistory.exists() && !def_dictionaries.exists()) return false;
       
       try {
           if (def_wordhistory.exists()) def_wordhistory.moveTo(midDirectory, "mid_words_history.txt");
           if (def_dictionaries.exists()) def_dictionaries.moveTo(midDirectory, "mid_default_dictionaryset.txt");
       } catch (e) {
           if (e.name == "NS_ERROR_FILE_ACCESS_DENIED") {
               this.util.localAlert("file.access.denied", " : " + midDirectory.path);
           }
           else {
               alert("i/o error: " + e.name + "-" + e.message);
           }
           return false;
        };
    
        return true;

    }, 



    managePreferences : function () {

        var i, typ;

        /* get rid of old preferences */
        branch = midPrefs.getBranch("extensions.mid.dtype.");
        branch.deleteBranch("");

        /* First run, set factory default */                                                                                                      
        for (i = 0;                                                                                                                               
            (typ = document.getElementsByTagNameNS(this.midNS, "default-dict-type").item(i));                                                     
            i++) {                                                                                                                                
            var deftype = typ.getAttribute("label");                                                                                              
            if (midPrefBranch.getPrefType("extensions.mid.dtype." + deftype) != midPrefBranch.PREF_BOOL) {                                              
                midPrefBranch.setBoolPref("extensions.mid.dtype." + deftype, true);                                                                  
            }                                                                                                                                     
        }   
        /* manage layout */

        if (midPrefBranch.getPrefType("extensions.mid.layout.browserup") == midPrefBranch.PREF_BOOL) {
            if (midPrefBranch.getBoolPref("extensions.mid.layout.browserup")) {
                var t = domHelper.tabboxElement;
                var s = domHelper.browserSplitter;
                var b = domHelper.browserBox;
                var p = b.parentNode;
                p.removeChild(b);
                p.removeChild(t);
                p.insertBefore(b, s);
                p.appendChild(t);
            }
        }

        if (midPrefBranch.getPrefType("extensions.mid.layout.widescreen") == midPrefBranch.PREF_BOOL) {
            if (midPrefBranch.getBoolPref("extensions.mid.layout.widescreen")) {
                domHelper.main_container.setAttribute("orient","horizontal");
                domHelper.browserSplitter.orient="horizontal";
            } else  {
                domHelper.main_container.setAttribute("orient","vertical");
                domHelper.browserSplitter.orient="vertical";
            }
        }


        /* get throbber setting */

        if (midPrefBranch.getPrefType("extensions.mid.disable.throbber") == midPrefBranch.PREF_BOOL) {
            if (midPrefBranch.getBoolPref("extensions.mid.disable.throbber")) {
                this.WebProgressListener.throbberDisabled = true;
            }
        };
        if (midPrefBranch.getPrefType("extensions.mid.fullPageZoom") == midPrefBranch.PREF_INT) {
            this.fullPageZoom = midPrefBranch.getIntPref("extensions.mid.fullPageZoom")/100;
        }
        this.branch = midPrefs.getBranch("extensions.mid.");
        this.branch.QueryInterface(Components.interfaces.nsIPrefBranch2);
        this.branch.addObserver("", this, false);
    },

    
    removeAllPreferences : function () {
        
        if (!this.util.confirm(this.util.getLocaleString("delete.allpreferences"))) {
            return;
        }
    
        var branch = midPrefs.getBranch("extensions.mid.");
        branch.deleteBranch("");
        this.removeDefaultSet();
    
        var popup = document.getElementById("mid_lastusedfilespopup");
        while (popup.childNodes.length > 1) {
            popup.removeChild(popup.lastChild);
        }
    
        // this.changeDictionaryName("default");
        this.loadDictionaries();
        this.util.localAlert("revert.to.original.settings","");
    },

    
    arrangeLUFPrefs : function (aLUF) {
        
        var conv = Cc["@mozilla.org/intl/scriptableunicodeconverter"].
                       createInstance(Ci.nsIScriptableUnicodeConverter);
        conv.charset = "UTF-8";
        
        var file            = aLUF;
        var savedFilesPrefs = midPrefs.getBranch("extensions.mid.lastusedsets.");
        var children        = savedFilesPrefs.getChildList("", {});
        var sortedLUFPrefs  = children.sort(); // 
        var newChildren     = [];
        var usedFile        = ""; 

        newChildren.push(file);
    
        for (i = 0; i < children.length; i++) {
            if (savedFilesPrefs.prefHasUserValue(sortedLUFPrefs[i])) {
                var nFile = savedFilesPrefs.getComplexValue(sortedLUFPrefs[i], Ci.nsILocalFile);
                if (nFile.path != file.path) {
                    newChildren.push(nFile);
                }
            }
        }
    
        var limit = Math.min(this.MAXREOPENFILES, newChildren.length);
    
        for (i = 0; i < limit; i++) {
            savedFilesPrefs.setComplexValue(i + 1, Ci.nsILocalFile, newChildren[i]);
        }
    
        // TODO:more testing ...
        for (i = newChildren.length + 1; i < this.MAXREOPENFILES + 1; i++) {
            if (savedFilesPrefs.prefHasUserValue(i)) {
                savedFilesPrefs.clearUserPref(i);
            }
        }
        
        // try {
        //    usedFile = conv.ConvertToUnicode(savedFilesPrefs.getCharPref("1"));
        // } catch (e) {
        //    usedFile = savedFilesPrefs.getCharPref("1");
        // }

        // document.getElementById("mid_stat_dictset").value = file.path;
        return true;
    },
    
    reOpen : function () {
    
        var savedFilesPrefs = midPrefs.getBranch("extensions.mid.lastusedsets.");
        var children        = savedFilesPrefs.getChildList("", {});
    
        var conv = Cc["@mozilla.org/intl/scriptableunicodeconverter"].
                       createInstance(Ci.nsIScriptableUnicodeConverter);
        conv.charset = "UTF-8";
    
        var menuitem;
        var popup = document.getElementById("mid_lastusedfilespopup");
    
        var popupMenuItems = popup.getElementsByTagName("menuitem");
    
        if ( children.length > 0 && popupMenuItems.length == 1 ) {
            var separator = document.createElement("menuseparator");
     	    popup.appendChild(separator);
        }
    
        var sortedLUFPrefs=children.sort();
    
        for (i = 0; i < children.length; i++ ){ 
    	    if ( ! savedFilesPrefs.prefHasUserValue( sortedLUFPrefs[i] ) ) continue;
    
    	    var file =  savedFilesPrefs.getComplexValue( sortedLUFPrefs[i], Ci.nsILocalFile);
    	    try {
    	      var menulabel = conv.ConvertToUnicode(savedFilesPrefs.getCharPref(sortedLUFPrefs[i]));
    	    } catch (e) { menulabel = savedFilesPrefs.getCharPref(sortedLUFPrefs[i]);
    	    }
    	    if (  popupMenuItems.length < this.FIRSTDYNAMICMENUITEM + i ) {   // existing menuitem?
                   menuitem = document.createElement("menuitem");
                   popup.appendChild(menuitem);
    	    } else {
    	      menuitem = popupMenuItems.item(i+1); 
    	    }
    	    menuitem.setAttribute("label", menulabel );
            menuitem.setAttribute("prefnum", i );
        }
        return true;
    },
    


     getDefaultSetFile : function () {   

        var file = Cc["@mozilla.org/file/directory_service;1"].getService(Ci.nsIProperties)
                 .get("ProfD", Components.interfaces.nsIFile);
        file.append("mid");
        file.append("mid_default_dictionaryset.txt");

        return file;
 
     },

 

    removeDefaultSet: function () {

        file = this.getDefaultSetFile();
    
        try {
            if (file.exists()) {
                file.remove(false);
            }
        } catch (e) {
            if (e.name == "NS_ERROR_FILE_ACCESS_DENIED") {
                this.util.localAlert("file.access.denied", "");
            }
            else {
                alert("i/o error: " + e.name + "-" + e.message);
            }
            return false;
        }
    },



    changeDictionaryName : function (dName) {

        this.dictionary = dName;
        switch (this.dictionary) {
        case "temporary":
            // document.getElementById("mid_stat_dictset").value = this.util.getLocaleString("temporary.set");                 
            break;
        case "default": 
            // document.getElementById("mid_stat_dictset").value = 
            // this.util.getLocaleString("default.set");
            break;
        default: 
            //document.getElementById("mid_stat_dictset").value = dName;
        }
    },
  

 
    setBrowserURL : function () {
        domHelper.browserBrowser.docShell.allowPlugins = false;
        try {
            domHelper.browserBrowser.addProgressListener(this.WebProgressListener,
    		                          Ci.nsIWebProgress.NOTIFY_STATE_NETWORK);
            } catch (e) {
                alert("addProgressListener failed");
            } 
        /* Started from a browser */
        if (window.opener && window.opener.content.location.href !== "") {
            var midBrowserStartLocation = window.opener.content.location.href; 
            domHelper.browserBrowser.setAttribute("src", midBrowserStartLocation);
            domHelper.urlElement.value = midBrowserStartLocation;
        }
        if (window.location == "chrome://mid/content/mid.xul?tab") {  // runing in tab
            document.getElementById("mid_syncurlbutton").setAttribute("collapsed","false");
        }
        if (window.opener) {
            document.getElementById("mid_syncurlbutton").setAttribute("collapsed","false");
        }
    },



    syncBrowserURL : function () {

        const nsIWindowMediator = Components.interfaces.nsIWindowMediator; 
        var windowMediator = Components.classes['@mozilla.org/appshell/window-mediator;1'].getService(); 

        windowMediator = windowMediator.QueryInterface(nsIWindowMediator);
        var win = windowMediator.getMostRecentWindow("navigator:browser");

        if ( win && win.gBrowser) {
            domHelper.browserBrowser.setAttribute("src", win.gBrowser.contentWindow.location);
            domHelper.urlElement.value = win.gBrowser.contentWindow.location;
        }
    },



    appendToOldDictionaries : function (midlines) {

        var mytabpanels = domHelper.tabpanelsElement;
        var nArray = [], dictid, i;

        if (this.olddictionary == this.dictionary || this.fromDialog) {
            for (i = 0; (iBrowser = mytabpanels.getElementsByTagName("browser").item(i)); i++) {
                dictid = iBrowser.xmlDic.getAttribute("dictid");
                if (this.util.inArray(midlines, dictid)) {
                    nArray.push(dictid);
                }
            }
        }
    
        this.olddictionary = this.dictionary;

        if (!midlines) {
            return nArray;
        }

        for (i = 0; i < midlines.length; i++) {
            if (this.util.inArray(nArray, midlines[i]) !== true) {
                nArray.push(midlines[i]);
            }
        }
        return nArray;
    },

    
    loadDictionaries : function (midlines) {
    
        var i,j, xmlDic, dictType, dictChecked, dtchecked, dictId;
        var newDicos = [];
        var ITomb    = [];
        var DTomb    = [];
    
        var tps = domHelper.tabpanelsElement;
        var mytabs = domHelper.tabsElement;
    
        newDicos = this.appendToOldDictionaries(midlines);
        // if (midlines) 

        this.tabManager.removeTabs();   
        
        if (midlines) {
            for (j = 0; (j < midlines.length); j++) {
                ITomb[j]=-1;
            }
        }

 
        for (i = 0; (xmlDic = document.getElementsByTagNameNS(this.midNS, "dict").item(i)); i++) {
            dictId      = xmlDic.getAttribute("dictid");
            dictType    = xmlDic.getAttribute("type");
    	
            if (midlines) {
                if (newDicos && (newDicos.join().indexOf(dictId) > -1)) { // csunya
                    DTomb.push(newDicos.join().indexOf(dictId) / 37);
                    ITomb[newDicos.join().indexOf(dictId) / 37] = i;
                }
            }   
            if (!midlines) {
                if (this.checkDictChecked(xmlDic)) {
                    if (!this.util.inArray(newDicos, dictId)) {
                        newDicos.push(dictId);
                    }
                    DTomb.push(newDicos.join().indexOf(dictId) / 37); 
                    ITomb[newDicos.join().indexOf(dictId) / 37] = i;
                }
            } 
    
        } // for
    
        for (var k in DTomb) {
            if (DTomb.hasOwnProperty(k)) {
                xmlDic = document.getElementsByTagNameNS(this.midNS, "dict").item(ITomb[k]);
                if (xmlDic) {
                    this.tabManager.createDictionaryTab(xmlDic);
                }
            }
        }
    
        DTomb = null;
        ITomb = null;
    
         /* Add progress listeners and find first not collapsed */
    
        var selecteditem = 0; 
        var myBrowser;
    
        for (i = tps.getElementsByTagName("browser").length - 1;
            (myBrowser = tps.getElementsByTagName("browser").item(i));
            i--) {
            myBrowser.docShell.allowJavascript = true;

            if (myBrowser.xmlDic.getAttribute("js") == "disabled") { 
                myBrowser.docShell.allowJavascript = false;
            }
            selecteditem = i;
            try {
                myBrowser.addProgressListener(this.WebProgressListener,
    		                          Ci.nsIWebProgress.NOTIFY_STATE_NETWORK);
            } catch (e) {
                alert("addProgressListener failed");
            } 
            myBrowser.docShell.QueryInterface(Components.interfaces.nsIDocShellHistory).useGlobalHistory = false;
        }
        mytabs.selectedIndex = selecteditem;
        
        this.fromDialog = false; 
    },
 
    checkDictChecked : function (xmlDic) {
    
        var dictChecked = false;
        var typeChecked = false;
    
        var dictType    = xmlDic.getAttribute("type");
        var dictId      = xmlDic.getAttribute("dictid");
    
        if (midPrefBranch.getPrefType("extensions.mid.dtype." + dictType) == midPrefBranch.PREF_BOOL) {
            typeChecked = midPrefBranch.getBoolPref("extensions.mid.dtype." + dictType);
        } 
        else {
            return false;
        }
        if (!typeChecked) { 
            return false;
        }
    
        if (midPrefBranch.getPrefType("extensions.mid." + dictId + "_checked") == midPrefBranch.PREF_BOOL) {
            dictChecked = midPrefBranch.getBoolPref("extensions.mid." + dictId + "_checked");
        } else {
            xmlDic.getAttribute("checked") == "true" ? dictChecked = true : dictChecked = false; 
        }
    
        if (!dictChecked) {
            return false;
        }
    
        return true;
    },

    getOtherPreferences : function () {
        openDialog("mid_prefwindow.xul", "Preferences", "modal=1,dialog=1,chrome=1,centerscreen=1,resizable=0", null);
    },
    
    getDictionaryPreferences : function () {
    
        var midDictArg = {}, midlines = [] ;
    
        // this.saveDSet();
    
        if (this.dictionary === "new") {
            // this.tabManager.removeTabs();   
            this.tabManager.collapseTabs(true);   
        }
    
        midDictArg.dictionary = this.dictionary;
        this.olddictionary = this.dictionary;
        this.fromDialog = true;
        openDialog("choose_dict.xul", "pref",
                   "modal=1,dialog=1,chrome=1,centerscreen=1,resizable=0", midDictArg);

        if (this.dictionary === "new")
           if ( midDictArg.dictionary == "cancelled" ) {
            this.tabManager.collapseTabs(false);
            this.dictionary="cancelled";
            return;   
        }
 

        if (midDictArg.dictionary == "cancelled" ) {
            this.dictionary="cancelled";
            // mid_mud.fileManager.restoreDefaultSet(); 
 	    return;	
        };

        if (midDictArg.dictionary === "new" || midDictArg.dictionary === "saveas") {
            mid_mud.fileManager.saveSetAs(); // changes dictionary name
            if (this.dictionary === "new" || this.dictionary === "") {    
                // this.changeDictionaryName("temporary");
            }
            else {
                // this.saveDSet();
            }
        } 
        else {
            // this.changeDictionaryName(midDictArg.dictionary);
        }
    
        if (midDictArg.mylines) {
            midlines = midDictArg.mylines;
            this.loadDictionaries(midlines);
        } else {
            if (midDictArg.result) {
                this.loadDictionaries();
            }
        }
        this.fromDialog = false;
    }, 

    newDictionarySet : function () {
        // this.saveDSet();
        this.dictionary = "new";
        this.getDictionaryPreferences();

    },

    saveDSet : function () {
        //  if (!this.util.confirm(this.util.getLocaleString("dictionaryset.save.changes"))) return;
        if ((this.dictionary === "temporary") || (this.dictionary === "new")) {
            return;
        }
    
        if (this.dictionary === "default") {
            this.fileManager.saveDefaultSet();
            return;
        }
        this.fileManager.saveNamedSet();
    },

    updateStatusBarCounter : function () {
       document.getElementById("mid_stat_counter").value = mid_mud.transMemory.getRowCount();
    },

    observe : function (aSubject, aTopic, aData) {
        // alert(aData);
        if (aTopic != "nsPref:changed") {
           return;
        }

        if (aData == "fullPageZoom") {
           // alert (aSubject);
           mid_mud.tabManager.setZoomAll();
        }

        if (aData == "layout.browserup") {
            mid_mud.layoutManager.setBrowserLayout();
        }

        if (aData == "layout.widescreen") {
            if (domHelper.main_container.orient == "vertical") {
                domHelper.main_container.orient = "horizontal";
                domHelper.browserSplitter.orient = "horizontal"
            } else {
                domHelper.main_container.orient = "vertical";
                domHelper.browserSplitter.orient = "vertical";
            }
        }
/***
        if (aData == "session.type") {
            if (midPrefBranch.getIntPref("extensions.mid.session.type") == 1) {
                mid_mud.midSession.restore(); 
            }
        }
***/
    }
};

 

// members //

mid_mud.WebProgressListener = {

    progresscounter : 0,
    throbberDisabled : false,


    QueryInterface: function (iid) {
        if (iid.equals(Ci.nsIWebProgressListener) ||
            iid.equals(Ci.nsISupportsWeakReference) ||
            iid.equals(Ci.nsISupports)) {
            return this;
        }
        throw Components.results.NS_ERROR_NO_INTERFACE;
    },

    onProgressChange : function (wp, req, cur, max, curtotal, maxtotal) {},

    onStateChange : function (wp, req, state, status) {
        if ((state & Ci.nsIWebProgressListener.STATE_STOP) &&
           (state & Ci.nsIWebProgressListener.STATE_IS_WINDOW)) {
                if (wp.DOMWindow == wp.DOMWindow.top)
                window.mid_mud.tabManager.setZoom(wp.DOMWindow);
           }
        if ((state & Ci.nsIWebProgressListener.STATE_STOP) && 
           (state & Ci.nsIWebProgressListener.STATE_IS_NETWORK)) {
            if (this.progresscounter > 0) { 
                this.progresscounter = this.progresscounter - 1;
            }
            if (this.progresscounter === 0) {
                document.getElementById("mid_stoploadbutton").disabled = true;
            }
            if (!this.throbberDisabled) { 
                mid_mud.util.settimeout(window.mid_mud.tabManager.setThrobber, 0, wp.DOMWindow, false); 
            }
        } 
        if ((state & Ci.nsIWebProgressListener.STATE_START) && 
            (state & Ci.nsIWebProgressListener.STATE_IS_NETWORK)) {
            document.getElementById("mid_stoploadbutton").disabled = false;
            this.progresscounter = this.progresscounter + 1;

            if (!this.throbberDisabled) {
                mid_mud.util.settimeout(window.mid_mud.tabManager.setThrobber, 0, wp.DOMWindow, true);
            }
        }
        if ((state & Ci.nsIWebProgressListener.STATE_TRANSFERRING)) {
            if (!this.throbberDisabled) {
                mid_mud.util.settimeout(window.mid_mud.tabManager.setThrobber, 0, wp.DOMWindow, false);
            }
        }
    },
    onLocationChange : function (wp, req, loc) {
    },
    onStatusChange : function (wp, req, status, message) {},
    onSecurityChange : function (wp, req, state) {}
};



mid_mud.focusManager = {

    preventFocusReset : false,
    lastfocused : "micimacko",

    focusSearchField : function () {
	domHelper.inputElement.focus();
        domHelper.f2.setAttribute("class", "midf2hidden");
        this.preventFocusReset = false;
    },

    checkFocusedElement :  function (event) {
        if (window.fullScreen) {
            this.preventFocusReset = true; 
            return;
        } // there is no input field
    
    
        if (this.preventFocusReset) {
            return;
        }

        var cmdDispatcher = document.commandDispatcher;
        if (typeof event.target != "undefined") 
        if (event.target.id && event.target.id == "mid_Url") {
            this.preventFocusReset = true;
        }
    
        if (cmdDispatcher.focusedElement) {
            if (cmdDispatcher.focusedElement.tagName) { 
                if (cmdDispatcher.focusedElement.id == "mid_searchWord") {
                    domHelper.f2.setAttribute("class", "midf2hidden");
                }
                if (cmdDispatcher.focusedElement.tagName != this.lastfocused) { // tagName ?? hm hm
                    this.lastfocused = cmdDispatcher.focusedElement.tagName;
                    mid_mud.util.settimeout(window.mid_mud.focusManager.focusSearchField, 20);
                }
            } else { 
                mid_mud.util.settimeout(window.mid_mud.focusManager.focusSearchField, 20);
            }
        } else {
            mid_mud.util.settimeout(window.mid_mud.focusManager.focusSearchField, 20);
        }
    
    },
    
    checkClickedElement : function (event) {
	this.preventFocusReset = true;
    },

    checkKeypressElement : function (event) {
        var code = event.charCode || event.keyCode;
        mid_mud.util.dumpToConsole("keypress");
        mid_mud.util.dumpToConsole("-" + code + "- ");
 
        var code = event.charCode || event.keyCode;

        if (( code == 113 ) ||  ( code == 107 && event.ctrlKey))  {
            event.preventDefault();
            event.stopPropagation();
            mid_mud.focusManager.focusSearchField();  return;
        }

        if (event.originalTarget) {
            if (event.originalTarget.id && event.originalTarget.id == "mid_searchWord") {
                this.preventFocusReset = false;
            }
            if (event.originalTarget.tagName && event.originalTarget.tagName == "HTML") {
                this.preventFocusReset = true;
            }
        } else {
            this.preventFocusReset = false;
        }
  
        if ((event.keyCode == 9) || ( event.keyCode == 114)) {
            this.preventFocusReset = true;
            if (event.keyCode == 114) { 
               event.preventDefault(); 
               event.stopPropagation();
               mid_mud.finder.findStringOnPage(event);
           } 
        }
    }
};


 
function domHelperObject() {
    this.tabpanelsElement = document.getElementById("mid_tabpanels");
    this.tabsElement      = document.getElementById("mid_tabs");
    this.tabboxElement    = document.getElementById("mid_tabbox");
    this.inputElement     = document.getElementById("mid_searchWord");
    this.f2               = document.getElementById("mid_focusLabel");
    this.browserBrowser   = document.getElementById("mid_MainBrowser");
    this.menubarElement   = document.getElementById("mid_menubar");
    this.statusbarElement = document.getElementById("mid_statusbar");
    this.browserSplitter  = document.getElementById("mid_BrowserSplitter");
    this.browserBox       = document.getElementById("mid_BrowserBox");
    this.wordsTree        = document.getElementById("mid_wordstree");
    this.urlElement 	  = document.getElementById("mid_Url");
    this.sideBar          = document.getElementById("mid_sidebar");
    this.main_container   = document.getElementById("mid_main_container");
};   


mid_mud.tabManager = {
    
    tabIconic : "false" ,

    Init : function () {
        var cButton;
        this.tabPanelsElement = domHelper.tabpanelsElement;
        this.tabsElement      = domHelper.tabsElement;
        this.tabIconic        = this.tabsElement.getAttribute("iconic"); 
        cButton = document.getAnonymousElementByAttribute(this.tabsElement,"iconic", true)
        if (cButton) {
            if (this.tabIconic != "true" ) { 
                cButton.setAttribute("iconic", "false");
                cButton.setAttribute("tooltiptext", mid_mud.util.getLocaleString('tabs.tooltiptext.hidetext'));
            }
            else {
                cButton.setAttribute("iconic", "true");
                cButton.setAttribute("tooltiptext", mid_mud.util.getLocaleString('tabs.tooltiptext.showtext'));
            }
        }
 
    },
 
    createDictionaryTab : function (xmlDic) {
    
        var   newTab, newBrowser;
        newTab = document.createElement("tab");

        mid_mud.util.populateWithAttributes(newTab,
            "id",          "tab" + xmlDic.getAttribute("dictid"),
            "context",     "mid_tabcontextpopup",
            "label",       xmlDic.getAttribute("label"),
            "image",       xmlDic.getAttribute("fav"),
            "tooltiptext", xmlDic.getAttribute("label") + " : " + xmlDic.getAttribute("home"),
            "dicthome",    xmlDic.getAttribute("home"),
            "iconic",      this.tabIconic); 
    
        this.tabsElement.appendChild(newTab);
    
        newBrowser    = document.createElement("browser");
        newBrowser.xmlDic = xmlDic;
	    mid_mud.util.populateWithAttributes(newBrowser,
            "id",          "b" +  xmlDic.getAttribute("dictid"),
            "type",        "content",
            "context",     "mid_browsercontextpopup",
            "src",         xmlDic.getAttribute("home"),
            "homepage",    xmlDic.getAttribute("home"),
            "ondblclick", "mid_mud.lookup.lookupFromContext()");
    
        this.tabPanelsElement.appendChild(newBrowser);
    }, 
    
    styleTabs : function (event) {

        var curtab, curpanel, i 
    
        if (event) {
            var cButton = event.originalTarget;
            if (cButton.localName != "toolbarbutton") {
                return; // elsewere on tabs
            }
        }
    
        for (i = 0; (curtab = this.tabsElement.getElementsByTagName("tab").item(i)); i++) {
            curpanel = document.getElementById(curtab.linkedpanel);
            if (this.tabIconic == "true" ) {
                curtab.setAttribute("iconic", "false");
            }
            else  {
                curtab.setAttribute("iconic", "true");
            }
        }
    
        if (cButton) {
            if (this.tabIconic == "true" ) { 
                cButton.setAttribute("iconic", "false");
                cButton.setAttribute("tooltiptext", mid_mud.util.getLocaleString('tabs.tooltiptext.hidetext'));
                this.tabIconic = "false"
            }
            else {
                cButton.setAttribute("iconic", "true");
                cButton.setAttribute("tooltiptext", mid_mud.util.getLocaleString('tabs.tooltiptext.showtext'));
                this.tabIconic = "true"
            }
        }
        domHelper.tabsElement.setAttribute("iconic", this.tabIconic);
    },
    
    removeTabs : function () {

        while (this.tabPanelsElement.hasChildNodes()) {
            try {
                this.tabPanelsElement.firstChild.removeProgressListener(mid_mud.WebProgressListener);
            } 
            catch (e) {
                alert("removeProgressListener failed");
            } 
            this.tabPanelsElement.removeChild(this.tabPanelsElement.firstChild);
        }
    
        while (this.tabsElement.hasChildNodes()) {
            this.tabsElement.removeChild(this.tabsElement.firstChild);
        }
    },

    collapseTabs : function (aCollapsed) {
        var curtab;
        for (i = 0; (curtab = this.tabsElement.getElementsByTagName("tab").item(i)); i++) {
            curtab.setAttribute("collapsed", aCollapsed);
        }
 
    },
        
    setThrobber : function (dm, image) {

        var dwin = dm;
        if (!(dwin && dwin.location)) {          // ff2
            return;
	    }
        // alert(dwin.location.href);
        var tabsArray      = domHelper.tabsElement.getElementsByTagName("tab");
        var tabPanelsArray = domHelper.tabpanelsElement; // this.tabPanelsElement;

        var i, iBrowser, iTab;
        for (i = 0;(iBrowser = tabPanelsArray.getElementsByTagName("browser").item(i)); i++) {
            iTab = tabsArray.item(i);
            if (iBrowser.currentURI && iBrowser.currentURI.spec == dwin.document.location.href) {
                if (image) {
                    iTab.setAttribute("busy", "true");
                    iTab.removeAttribute("image");
                }
                else {
                    if (iTab.hasAttribute("busy")) {
                        iTab.removeAttribute("busy");
                        iTab.setAttribute("image", iBrowser.xmlDic.getAttribute("fav"));
                    }
                }
            }
        }
    
    },

   setZoom : function (dm) {

        var dwin = dm;
        if (!(dwin && dwin.location)) {          // ff2
            return;
	    }

        var tabPanelsArray = domHelper.tabpanelsElement; 

        var i, iBrowser ;
        for (i = 0;(iBrowser = tabPanelsArray.getElementsByTagName("browser").item(i)); i++) {
            if (iBrowser.currentURI && iBrowser.currentURI.spec == dwin.location.href) {
               iBrowser.markupDocumentViewer.fullZoom = mid_mud.fullPageZoom;              
               return;
            }
        }
        if (domHelper.browserBrowser.currentURI.spec == dwin.document.location.href) {
               domHelper.urlElement.value=dwin.document.location.href;
               domHelper.browserBrowser.markupDocumentViewer.fullZoom = mid_mud.fullPageZoom;              
        }
    },


    setZoomAll : function () {
        // 666 van ilyen? 
        mid_mud.fullPageZoom = midPrefBranch.getIntPref("extensions.mid.fullPageZoom")/100;    
        var i, iBrowser ;
        for (i = 0;(iBrowser = document.getElementsByTagName("browser").item(i)); i++) {
            iBrowser.markupDocumentViewer.fullZoom = mid_mud.fullPageZoom;
        }
    },

    closeTab : function () {
    
        var dictTabId     = document.popupNode.id;
        var dictBrowserId = dictTabId.replace("tab", "b");
    
        var dictTabToRemove     = document.getElementById(dictTabId);
        var dictBrowserToRemove = document.getElementById(dictBrowserId);
    
        if (dictTabToRemove.getAttribute("selected", "true")) {
            this.tabsElement.advanceSelectedTab(1, true);
        }
    
        try {
            dictBrowserToRemove.removeProgressListener(mid_mud.WebProgressListener);
        }
        catch (e) {}
    
        this.tabPanelsElement.removeChild(dictBrowserToRemove);
        this.tabsElement.removeChild(dictTabToRemove);
    
        this.tabPanelsElement.selectedIndex = this.tabsElement.selectedIndex; //??
        var dictId = dictTabId.replace("tab", "");
        midPrefBranch.setBoolPref("extensions.mid." + dictId + "_checked", false);
    
    },

    openHomePage : function () {
        var dictTab = document.getElementById(document.popupNode.id);
        window.open(dictTab.getAttribute("dicthome"));
    },

    dictTabPopupShowing :  function () {
        // nothing to do as for now 
        // alert(document.popupNode.id);
    },

    dragAndDrop : {
        onDragStart: function (event, transferData, action) {
            var tabArray = domHelper.tabsElement.getElementsByTagName("tab");
            var myIndex = -1;
            for (var i = 0; i < tabArray.length; i++) {
                if (event.target.id == tabArray[i].id) {
                    myIndex = i;
                }
            }
          //   mid_mud.util.dumpToConsole(myIndex);
            if (myIndex == -1) {
                return;
            }
            this.index = myIndex;
            transferData.data = new TransferData();
            transferData.data.addDataForFlavour("text/x-mid-tab", 'nyul');
        },
            
        getSupportedFlavours : function () {
            var flavours = new FlavourSet();
            flavours.appendFlavour("text/x-mid-tab");
            return flavours;
        },
    
        onDragOver : function(event,flavour,session) {
            return true; 
        },
    
        onDragEnter : function(event, session) {
        },
    
        onDragExit : function(event, session) {
        },
    
        canDrop: function(event, session) { 
            if (session.sourceNode &&
                 session.sourceNode.parentNode == domHelper.tabsElement &&
                 ((event.screenX >= session.sourceNode.boxObject.screenX &&
                 event.screenX <= (session.sourceNode.boxObject.screenX +
                 session.sourceNode.boxObject.width)) &&
                 (event.screenY >= session.sourceNode.boxObject.screenY &&
                 event.screenY <= (session.sourceNode.boxObject.screenY +
                 session.sourceNode.boxObject.height)))
                 )
            return false;
            return true;
        },
            
        onDrop: function (event, dropData, session) {
            var newIndex=this.getNewIndex(event);
            if (newIndex != this.index ) {
                this.moveTabTo(newIndex, session);
            }
        },
    
        moveTabTo: function (newIndex, session) {
            var tabs      = domHelper.tabsElement;
            var tabpanels = domHelper.tabpanelsElement;
            var draggedBrowser = tabpanels.getElementsByTagName("browser").item(this.index);
            var sh = draggedBrowser.sessionHistory;
            var originalHistory = this.copySessionHistory(sh);
            try {
                draggedBrowser.removeProgressListener(mid_mud.WebProgressListener);
            } catch (e) {} 
            tabs.insertBefore(session.sourceNode, tabs.getElementsByTagName("tab").item(newIndex));
            tabpanels.insertBefore(draggedBrowser, tabpanels.getElementsByTagName("browser").item(newIndex));
            tabs.selectedItem = session.sourceNode;
            tabpanels.selectedPanel = draggedBrowser;
            draggedBrowser.addProgressListener(mid_mud.WebProgressListener,
                                               Ci.nsIWebProgress.NOTIFY_STATE_NETWORK);
            this.restoreSessionHistory(draggedBrowser.webNavigation, originalHistory);
    
        },
    
        getNewIndex: function (event) {
            var tabArray = domHelper.tabsElement.getElementsByTagName('tab');
    
            for (var i = 0; i < tabArray.length; i++)
                if (event.clientX < tabArray[i].boxObject.x + tabArray[i].boxObject.width / 2) 
                    if (event.clientY < tabArray[i].boxObject.y + tabArray[i].boxObject.height)
                        return i;
    
            return tabArray.length;
        },
     
        copySessionHistory: function (originalHistory) {

            if (originalHistory===null) return;

            var range = {start : 0, length : originalHistory.count};
    
            var copiedHistory = [];
            for (var i = range.start; i < range.length; i++) {
                copiedHistory.push(originalHistory.getEntryAtIndex(i, false));
            }
            copiedHistory.index = originalHistory.index;
    
            return copiedHistory;
        },
    
        restoreSessionHistory: function (webNav, originalHistory) {

            function gotoHistoryIndex(attempts) {
                try {
                    webNav.gotoIndex(originalHistory.index);
                }
                catch (e) {
                    // do some math to increase the timeout
                    // each time we try to update the history index
                    if (attempts) {
                        mid_mud.util.settimeout(gotoHistoryIndex, (11 - attempts) * (15 - attempts), --attempts);
                    }
                }
            }
    
            var newHistory = webNav.sessionHistory;
    
            newHistory.QueryInterface(Components.interfaces.nsISHistoryInternal);
    
            // delete history entries if they are present
    
            if (newHistory.count > 0) {
                newHistory.PurgeHistory(newHistory.count);
            }
            for (var i = 0; i < originalHistory.length; i++) {
                var entry = originalHistory[i].QueryInterface(Components.interfaces.nsISHEntry);
                var newEntry = this.restoreHistoryEntry(entry);
                if (newEntry) {
                    newHistory.addEntry(newEntry, true);
                }
            }
    
            // Go to current history location
            if (originalHistory.index < originalHistory.length) {
                gotoHistoryIndex(10);
            }
        },
    
        restoreHistoryEntry: function (aEntry) {
            if (!aEntry) {
                return null;
            }
            aEntry = aEntry.QueryInterface(Components.interfaces.nsISHContainer);
            var newEntry = aEntry.clone();
            newEntry = newEntry.QueryInterface(Components.interfaces.nsISHContainer);
            newEntry.loadType = Math.floor(aEntry.loadType);
            if (aEntry.childCount) {
                for (var j = 0; j < aEntry.childCount; j++) {
                    var childEntry = this.restoreHistoryEntry(aEntry.GetChildAt(j));
                    if (childEntry) {
                        newEntry.AddChild(childEntry, j);
                    }
                }
            }
            return newEntry;
        } 
    
    }
      
};




mid_mud.layoutManager = {
    
    fullScreen : function () {
    
        var midmyelement, i;
        window.fullScreen = !window.fullScreen;
        document.getElementById("mid_viewFullScreen").setAttribute("checked", window.fullScreen);
    
        for (i = 0; (midmyelement = document.getElementsByTagName("toolbar").item(i)); i++) {
            midmyelement.setAttribute("collapsed", window.fullScreen);
        }
    
        for (i = 0; (midmyelement = document.getElementsByTagName("statusbar").item(i)); i++) {
            midmyelement.setAttribute("collapsed", window.fullScreen);
        }
    
        for (i = 0; (midmyelement = document.getElementsByTagName("menubar").item(i)); i++) {
            midmyelement.setAttribute("collapsed", window.fullScreen);
        } 
       
    },
    
    browserView : function  () { 
        var browserSplitter = domHelper.browserSplitter; 
        var browser = domHelper.browserBox; 
        if (browser.getAttribute("collapsed") == "true") { 
            document.getElementById("mid_viewpopupbrowseritem").setAttribute("checked", "true"); 
            browser.setAttribute("collapsed", "false"); 
            browserSplitter.setAttribute("collapsed", "false"); 
            domHelper.urlElement.value = domHelper.browserBrowser.contentWindow.location;
        } else { 
            document.getElementById("mid_viewpopupbrowseritem").setAttribute("checked", "false"); 
            browser.setAttribute("collapsed", "true"); 
            browserSplitter.setAttribute("collapsed", "true"); 
        }
    },
        
    setBrowserLayout : function () { 
        function setUrl () {
           domHelper.urlElement.value = domHelper.browserBrowser.currentURI.spec
        };
        var t = domHelper.tabboxElement;
        var s = domHelper.browserSplitter;
        var b = domHelper.browserBox;
        var p = b.parentNode;
        var mBrowser = domHelper.browserBrowser;
        var sh = mBrowser.sessionHistory;
        var originalHistory = mid_mud.tabManager.dragAndDrop.copySessionHistory(sh);
        try {
            mBrowser.removeProgressListener(mid_mud.WebProgressListener);
        } catch (e) {}
        
        if (midPrefBranch.getBoolPref("extensions.mid.layout.browserup")) {
            p.insertBefore(s,t);
            p.insertBefore(b,s);
        } else {
            p.appendChild(s);
            p.appendChild(b);
        }
        mBrowser.addProgressListener(mid_mud.WebProgressListener, Ci.nsIWebProgress.NOTIFY_STATE_NETWORK);
        mid_mud.tabManager.dragAndDrop.restoreSessionHistory(mBrowser.webNavigation, originalHistory);
        mid_mud.util.settimeout (setUrl, 200);  // more precisely?
    },

    histView: function () {
        var histbox = document.getElementById("mid_histBox");
        if (histbox.getAttribute("collapsed") == "true") {
            document.getElementById("mid_viewpopuphistitem").setAttribute("checked", "true");
            histbox.setAttribute("collapsed", "false");
            domHelper.wordsTree.treeBoxObject.scrollByPages(1000);
        } else {
            document.getElementById("mid_viewpopuphistitem").setAttribute("checked", "false");
            histbox.setAttribute("collapsed", "true");
        }
        this.checkSideBar();
        if (histbox.getAttribute("collapsed") != "true") 
            mid_mud.util.settimeout (
            "{window.domHelper.wordsTree.treeBoxObject.ensureRowIsVisible(domHelper.wordsTree.view.rowCount-1);}"
            ,200)

    },

    checkSideBar: function () {
        
        var s = domHelper.sideBar;
        var sc = true;
        for (var i = 0; i < s.childNodes.length; i++) { 
             if ( s.childNodes[i].collapsed == false) {
                 sc = false;
                 break;
             }
         }
         s.collapsed = sc;
    }, 

     
    statusbarView: function () {
        var statusbar = domHelper.statusbarElement;
        if (statusbar.getAttribute("collapsed") == "true") {
            document.getElementById("mid_viewpopupstatusbaritem").setAttribute("checked", "true");
            statusbar.setAttribute("collapsed", "false");
        } else {
            document.getElementById("mid_viewpopupstatusbaritem").setAttribute("checked", "false");
            statusbar.setAttribute("collapsed", "true");
        }
    },
            
	
    googleTranslateView : function () {
        var gtSplitter = document.getElementById("mid_editor_splitter");
        var gt = document.getElementById("mid_googletranslateBox");
        if (gt.getAttribute("collapsed") == "true") {
            document.getElementById("mid_viewpopupgoogletranslatoritem").setAttribute("checked", "true");
            gtSplitter.setAttribute("collapsed", "false");
            gt.setAttribute("collapsed", "false");
        } else {
            document.getElementById("mid_viewpopupgoogletranslatoritem").setAttribute("checked", "false");
            gtSplitter.setAttribute("collapsed", "true");
            gt.setAttribute("collapsed", "true");
        }
        mid_mud.layoutManager.checkSideBar();
        if (gt.getAttribute("collapsed") != "true") 
           mid_mud.util.settimeout (
           "{window.domHelper.wordsTree.treeBoxObject.ensureRowIsVisible(domHelper.wordsTree.view.rowCount-1);}"
           ,200)
        }

};


mid_mud.helpMenu = {

    showAllDictionaries : function () {
    
        var myff = Cc["@mozilla.org/file/directory_service;1"]
            .getService(Ci.nsIProperties)
            .get("ProfD", Ci.nsIFile);
    
        var ios = Cc["@mozilla.org/network/io-service;1"]
            .getService(Ci.nsIIOService);
    
        var fileHandler = ios.getProtocolHandler("file")
            .QueryInterface(Ci.nsIFileProtocolHandler);
        /* simplify this */
        var fURL = "./dictionaries.xml";  
        var showDicos = {
    
            Firefox   : function () { window.open(fURL); },
            Iceweasel : function () { window.open(fURL); },
            Flock     : function () { window.open(fURL); }, // flock flock flock
            Netscape  : function () { window.open(fURL); },
            SeaMonkey : function () { window.open(fURL); },
            mid       : function () {
                var myff = Cc["@mozilla.org/file/directory_service;1"]
                    .getService(Ci.nsIProperties)
                    .get("resource:app", Ci.nsIFile);
                var URL  = fileHandler.getURLSpecFromFile(myff);
                var xURL = URL + "chrome/content/mid/dictionaries.xml";
                window.open(xURL);
               }
        };
    
        mid_mud.util.browserWrapper(showDicos);
    
    },

    aboutBox : function () {
        openDialog("about.xul", "About mid",
	    "chrome,resizeable,centerscreen,dialog,min-width=350px");
    },

    showHomePage : function () {
        window.open("http://mid.mozdev.org");
    }
    
};


mid_mud.fileManager = {
 
    fileWriter : function (file) {
    
        var fileStream =
        Cc["@mozilla.org/network/file-output-stream;1"].createInstance(Ci.nsIFileOutputStream);
       
        try {   
            fileStream.init(file, 0x04 | 0x08 | 0x20, 420, 0);
        } catch (e) {
            if (e.name == "NS_ERROR_FILE_ACCESS_DENIED") {
                mid_mud.util.localAlert("file.access.denied", "");
                return false; 
            } else {
                alert("fileManager.fileWriter: i/o error: " + e.name + "-" + e.message);   
                return false;
            }
        } 
      
        var i, dictTab, dictId;
        for (i = 0; (dictTab = document.getElementsByTagName("tab").item(i)); i++) {
            dictId = dictTab.id.replace(/^tab/, "") + ";" + dictTab.label;
            fileStream.write(dictId + "\n", dictId.length + 1);
        }
    
        fileStream.close();
        return true;
    },
    
    fileReader : function (file, midlines) {

        var is =
        Cc["@mozilla.org/network/file-input-stream;1"].createInstance(Ci.nsIFileInputStream);
  
        try {   
            is.init(file, 1, 444, false);  
        } catch (e) {
            if (e.name == "NS_ERROR_FILE_ACCESS_DENIED") { 
                mid_mud.util.localAlert("file.access.denied", "");
            }
            else { 
                alert("fileManager.fileReader: i/o error: " + e.name + "-" + e.message); 
            }
            return false;
        } 

        is.QueryInterface(Ci.nsILineInputStream);
        // read lines into array
        var midline = {}, hasmore;

        do {
            hasmore = is.readLine(midline);
            var dictId = midline.value.replace(/;.*$/, ""); 
            dictId = dictId.replace(/(.{37}).*/, "$1"); 
            midlines.push(dictId);
        } while (hasmore);

        is.close();
        return true;
    },

    saveSetAs : function () {  
    
        var nsIFilePicker = Ci.nsIFilePicker;
        var file;
    
        var fp = Cc["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
        fp.init(window, mid_mud.util.getLocaleString("choose.file"), nsIFilePicker.modeSave);
        fp.appendFilters(nsIFilePicker.filterAll);
    
        if (fp.show() == nsIFilePicker.returnCancel) {
            return false;
        }
        file = fp.file;

        if (!this.fileWriter(file)) {
            return false;
        }
   
        if (typeof(mid_mud.arrangeLUFPrefs) === "function") {
            mid_mud.arrangeLUFPrefs(file);
        }
    
        // mid_mud.util.localAlert("file.saved", "");
       //  mid_mud.changeDictionaryName(this.getDictionaryFilename());
    
    },

    
    saveNamedSet : function () {
        mid_mud.util.dumpToConsole("Saving to file");
        var file =  Components.classes["@mozilla.org/file/local;1"]
                         .createInstance(Components.interfaces.nsILocalFile);
        var savedFilesPrefs = midPrefs.getBranch("extensions.mid.lastusedsets.");
    
        if (savedFilesPrefs.prefHasUserValue(1)) {
            file = savedFilesPrefs.getComplexValue(1, Components.interfaces.nsILocalFile);
        }
        else { 
            return false;
        }
 
        if (!this.fileWriter(file)) {
            return false;
        }
        return true;
    },

    
    saveDefaultSet : function () {

        file = mid_mud.getDefaultSetFile();

        if (!this.fileWriter(file)) {
            return false;
        }
        return true;
   
    },
    
        
    restoreSet : function (filePrefNum, filename) {
        // mid_mud.util.dumpToConsole(filePrefNum);
        // mid_mud.saveDSet(); 
    
        var def, fp, file, midlines = [];

        var nsIFilePicker = Ci.nsIFilePicker;
    
        if (typeof(filePrefNum) != 'number') {
            fp = Cc["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
            fp.init(window, mid_mud.util.getLocaleString("choose.file"), nsIFilePicker.modeRead);
            fp.appendFilters(nsIFilePicker.filterAll);
            if (fp.show() == nsIFilePicker.returnCancel) {
                return false;
            }
            file = fp.file;
            filename = "";
        } else {
            var savedFilesPrefs = midPrefs.getBranch("extensions.mid.lastusedsets.");
            if (!savedFilesPrefs.prefHasUserValue(filePrefNum)) {
                mid_mud.util.localAlert("preference.not.found" , "extensions.mid.lastusedsets." + filePrefNum);
                return false;
            }
            file = savedFilesPrefs.getComplexValue(filePrefNum, Ci.nsILocalFile);
            if (!file.exists()) {
                mid_mud.util.localAlert("file.not.found", "");
                return false;
            }
        }
        
        if (!this.fileReader(file, midlines)) {
            return false;
	    };

        mid_mud.arrangeLUFPrefs(file);
    
        if (filename === "") {
            filename = this.getDictionaryFilename();
        }

        mid_mud.midFromRestore = true;   // not used
        // mid_mud.changeDictionaryName(filename);
        mid_mud.loadDictionaries(midlines);
        return true;
    },


    restoreNonDefaultSet : function (el) {
        if (!el.hasAttribute("prefnum")) return;
        var prefnum = Number(el.getAttribute("prefnum")) + 1;
        var label    = el.getAttribute("label");
        var filename = label.replace(/\\/g,'\\\\');                                                                                    
        mid_mud.fileManager.restoreSet(Number(prefnum), filename); 
    },

    restoreDefaultSet : function () {
        var midlines = [];
        if (mid_mud.dictionary != "default") {
            if (mid_mud.dictionary != "cancelled") {
                // mid_mud.saveDSet();
            }
        }

        // mid_mud.changeDictionaryName("default");
        file = mid_mud.getDefaultSetFile();

        if (!file.exists() || (file.fileSize == 0)) {
            // mid_mud.changeDictionaryName("default");
            mid_mud.loadDictionaries();
            return false;
        }
 
        if (!this.fileReader(file, midlines)) {
            return false;
        };


        mid_mud.midFromRestore = true;   // not used
        // mid_mud.changeDictionaryName("default");
        mid_mud.loadDictionaries(midlines);
        return true;
    },

    getDictionaryFilename : function () {
    
        var conv = Cc["@mozilla.org/intl/scriptableunicodeconverter"].
                createInstance(Ci.nsIScriptableUnicodeConverter);
        conv.charset = "UTF-8";
    
        var savedFilesPrefs = midPrefs.getBranch("extensions.mid.lastusedsets.");
        if (savedFilesPrefs.prefHasUserValue(1)) {
            return conv.ConvertToUnicode(savedFilesPrefs.getCharPref(1));
        }
        return "Unknown";
    
    }
        
};


mid_mud.lookup = {

    lookupAgain : function (event) {

        if (domHelper.wordsTree.editingColumn) return;

        var word = mid_mud.transMemory.getWord(event);
        if (!word) { 
            return; // editing definition
        }
    
        domHelper.inputElement.value = word.getAttribute("label");
    
        mid_mud.saveInHistory = false;
        this.lookupWord(null);
        mid_mud.saveInHistory = true;
    
    },
    

    lookupFromContext : function () {
        domHelper.inputElement.value = this.getSelectionForLookup();
        this.lookupWord(null); 
    },

    getSelectionForLookup :  function () {

        var selection = null;
        var focusedWindow = document.commandDispatcher.focusedWindow;
        selection = focusedWindow.getSelection();
       
        if (!selection) {
            return selection;
        }
    
        if (document.popupNode) {
            var node = document.popupNode;
            var nodeLocalName = document.popupNode.localName.toUpperCase();
            if ((nodeLocalName == "TEXTAREA") ||
               (nodeLocalName == "INPUT" && node.type == "text")) {
                selection = node.value.substring(node.selectionStart, node.selectionEnd);
            }
        }
        return selection;
    },

    convertLookupWord : function (b, w) {
   
        var chs = null, cw = "";
        var converter = Cc['@mozilla.org/intl/texttosuburi;1']
                       .createInstance(Ci.nsITextToSubURI);
   
        if (!(chs = b.xmlDic.getAttribute("inputencoding"))) {
           chs = b.contentDocument.characterSet;
        }
             
        try {
            cw = converter.ConvertAndEscape(chs, w);
        } catch (e) {
            cw = w;
        }
        return cw;
    },

    
    lookupWord : function (event) {
        
        if (event && event.originalTarget.nodeName == "treechildren") {
            return;
        }

        // lehet, hogy ez eleg
        if (event && event.originalTarget.nodeName == 'command' &&
            document.commandDispatcher.focusedElement.id != "mid_searchWord") {
            return;
        }
    
        var i, url, smyWord, myBrowser;
        var myWord = domHelper.inputElement.value;
    
        myWord = myWord.replace(/['"+!%\\\/=\(\)\[\]\{\},\.\-?:_ <>]*$/g, "");
        myWord = myWord.replace (/^\s*/,"");
        myWord = myWord.replace (/\s*$/,"");
        if (myWord == "") { 
            return; 
        }
    
        domHelper.inputElement.value = myWord;
    
        for (i = 0; (myBrowser = document.getElementsByTagName("browser").item(i)); i++) {
            if (myBrowser.getAttribute("id") != "mid_MainBrowser") {
                smyWord = this.convertLookupWord(myBrowser, myWord);
                if (myBrowser.xmlDic.getAttribute("method") == "POST") {
                    if (myBrowser.xmlDic.getAttribute("engine_name")) {
                       this.postInternalEngine(myBrowser, smyWord ) ; // FF's search engine
                    } else {
                       this.postURI(myBrowser, smyWord);
                    }
                } else {
                    if (myBrowser.xmlDic.getAttribute("method") == "func") {
                        searchfunction = myBrowser.xmlDic.getAttribute("function_name");
                        try {
                            mid_mud.dictSpecific[searchfunction](myBrowser, myWord);
                        } catch (e) { 
                            alert("Function error:" + searchfunction);
                        }
                    } else {
                        url = myBrowser.xmlDic.getAttribute("url");
                        if ( url != "" ) myBrowser.setAttribute("src", url.replace("XXX", smyWord));
                    } // normal
                }
            } 
        }     
    
        domHelper.inputElement.focus();
        domHelper.inputElement.setSelectionRange(0, domHelper.inputElement.textLength);
    
        mid_mud.backCounter++;

        mid_mud.dictBrowsers.updateImages();

        if (mid_mud.transMemory.getLastWord() == myWord) {        // same as the last word
            return;                               
        }
        if (!mid_mud.saveInHistory) {
            return;
        }
        mid_mud.transMemory.saveWordToTree(myWord, "");
        domHelper.wordsTree.treeBoxObject.ensureRowIsVisible(domHelper.wordsTree.view.rowCount-1);  
    },
    
    postURI : function (browser, word) {
    
        var dataString = browser.xmlDic.getAttribute("inputs").replace("XXX", word);
    
        var postData = Cc["@mozilla.org/network/mime-input-stream;1"].
                           createInstance(Ci.nsIMIMEInputStream);
    
        var stringStream = Cc["@mozilla.org/io/string-input-stream;1"].
                               createInstance(Ci.nsIStringInputStream);
    
        stringStream.setData(dataString, -1);
        postData.addHeader("Content-Type", "application/x-www-form-urlencoded");
        postData.addContentLength = true;
        postData.setData(stringStream);
    
        var url = browser.xmlDic.getAttribute("url");
    
        browser.webNavigation.loadURI(url,
                             browser.webNavigation.LOAD_FLAGS_NONE,
                             browser.currentURI ,
                             postData, null);
    
    },
    
    postInternalEngine : function  ( browser, word ) {
        var searchService = Components.classes["@mozilla.org/browser/search-service;1"].getService(Components.interfaces.nsIBrowserSearchService);
        var engine_name = browser.xmlDic.getAttribute("engine_name"); 
        var engine = searchService.getEngineByName(engine_name)
        if (!engine) {
            return 
        }
        var submission = engine.getSubmission(word, null);
        var postData = submission.postData;
        var url = browser.xmlDic.getAttribute("url");
        browser.webNavigation.loadURI(url,
                             browser.webNavigation.LOAD_FLAGS_NONE,
                             browser.currentURI ,
                             postData, null);


    }
        
        
};


mid_mud.mainBrowser = {

    popupShowing : function () {

        if (mid_mud.lookup.getSelectionForLookup() == '') {
            document.getElementById("mid_mainBCL").setAttribute("disabled", "true");
            document.getElementById("mid_mainBCC").setAttribute("disabled", "true");
        } else {
            document.getElementById("mid_mainBCL").setAttribute("disabled", "false");
            document.getElementById("mid_mainBCC").setAttribute("disabled", "false");
        }
    
        var mid_mb = domHelper.browserBrowser;
    
        if (mid_mb.canGoBack == false) {
            document.getElementById("mid_mainBCB").setAttribute("disabled", "true");
        } else {
            document.getElementById("mid_mainBCB").setAttribute("disabled", "false");
        }
    
        if (mid_mb.canGoForward == false){
            document.getElementById("mid_mainBCF").setAttribute("disabled", "true");
        } else {
            document.getElementById("mid_mainBCF").setAttribute("disabled", "false");
        }
    
    },

    goBack : function () {
        domHelper.browserBrowser.goBack();
    },
    
    goForward : function () { 
        domHelper.browserBrowser.goForward();
    },
    
    navigate : function () {
    
        var midUrl = domHelper.urlElement.value;
        var regexp = /^(([^:\/?#]+):)?(\/\/([^\/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;
        var ar = regexp.exec(midUrl);
        if (!ar[1]) {
            midUrl = "http://" + midUrl;
        }
    
        domHelper.browserBrowser.setAttribute("src", midUrl);

    
    }
        
};


mid_mud.dictBrowsers = {
    
    popupShowing : function (event) {
        //event.preventDefault();
        //event.stopPropagation();
    
        if (mid_mud.lookup.getSelectionForLookup() == "") {
            document.getElementById("mid_BCL").setAttribute("disabled", "true");
            document.getElementById("mid_BCC").setAttribute("disabled", "true");
        } else {
            document.getElementById("mid_BCL").setAttribute("disabled", "false");
            document.getElementById("mid_BCC").setAttribute("disabled", "false");
        }
    
        var myTabPanel = domHelper.tabpanelsElement;
    
        if (myTabPanel.selectedPanel.canGoBack === false) {
            document.getElementById("mid_BCB").setAttribute("disabled", "true");
        } else {
            document.getElementById("mid_BCB").setAttribute("disabled", "false");
        }
    
        if (myTabPanel.selectedPanel.canGoForward === false) {
            document.getElementById("mid_BCF").setAttribute("disabled", "true");
        } else {
            document.getElementById("mid_BCF").setAttribute("disabled", "false");
        }
    
    },

    allBrowsersStop : function () {
        var myBrowser;
        const nsIWebNavigation = Ci.nsIWebNavigation;
        const flags = nsIWebNavigation.STOP_ALL;

        for (i = 0; (myBrowser = document.getElementsByTagName("browser").item(i)); i++) {
            try {
                if (myBrowser.getAttribute("id") != "mid_MainBrowser") {
                    myBrowser.webNavigation.stop(flags);
                }
            } catch (e) {
                alert(myBrowser.getAttribute("homepage"));
            }
        }
    
    },
    
    updateImages : function () {
        var b = document.getElementById("back_image");
        var f = document.getElementById("for_image");
        if (mid_mud.forwardCounter < 1) {
            f.setAttribute("canwalk", "false");
        }
        else {
            f.setAttribute("canwalk", "true");
        }
        if (mid_mud.backCounter < 0) {
            b.setAttribute("canwalk", "false");
        } else { 
            b.setAttribute("canwalk", "true");
        }
    },
         
    thisBrowserBack : function () {
        domHelper.tabpanelsElement.selectedPanel.goBack();  
    
    },
    
    thisBrowserForward : function () {
        domHelper.tabpanelsElement.selectedPanel.goForward();  
    },
    
    allForward : function () {
    
        var myBrowser, word, i;
      
        if (mid_mud.forwardCounter < 0) {
            return false;
        }
    
        for (i = 0; (myBrowser = document.getElementsByTagName("browser").item(i)); i++) {
            if (myBrowser.getAttribute("id") == "mid_MainBrowser") {
                continue;
            }
            if (myBrowser.xmlDic.getAttribute("method") == "POST") {
                word = document.getElementsByTagName("treecell").item((mid_mud.backCounter + 1) * 2);
                if (word)
                    mid_mud.lookup.postURI(myBrowser, 
                    mid_mud.lookup.convertLookupWord(myBrowser,
                    word.getAttribute("label")));
                    
            } else { 
                if (myBrowser.webNavigation.canGoForward) {
                    myBrowser.webNavigation.goForward();
                }
            } 
        }
        mid_mud.backCounter++;
        mid_mud.forwardCounter--;
        mid_mud.dictBrowsers.updateImages();
    
    },

    allBack : function () {

        var myBrowser, word, i;
    
        if ( mid_mud.backCounter < -1 ) {
          return false;
        }

        for (i = 0; (myBrowser = document.getElementsByTagName("browser").item(i)); i++) {
            if (myBrowser.getAttribute("id") == "mid_MainBrowser") {
                continue;
            }
            if ((myBrowser.xmlDic.getAttribute("method") == "POST") && (mid_mud.backCounter!=0)) {
                word = document.getElementsByTagName("treecell").item((mid_mud.backCounter + 1) * 2);
                if (word) 
                   mid_mud.lookup.postURI(myBrowser,
                   mid_mud.lookup.convertLookupWord(myBrowser,
                   word.getAttribute("label")));

            } else { 
                if (myBrowser.webNavigation.canGoBack) {
                    myBrowser.webNavigation.goBack();
                }
            }
        }
        mid_mud.forwardCounter++;
        mid_mud.backCounter--;
        mid_mud.dictBrowsers.updateImages();
    
    }
    
};

          
mid_mud.finder = {

    positionToFirstHit : function (doc)  {
    
        var keres = domHelper.inputElement.value;
        var cw = doc.body.clientWidth / 2;
        var reps = new RegExp(keres, 'gi');
        var s  = doc.body.innerHTML.replace(reps, '<midtag>' + keres + '</midtag>');
        doc.body.innerHTML = s;
        var a = [];
        a = doc.getElementsByTagName("midtag");
        for (var i = 0; i < a.length; i++ ) {  
            var e = a[i];
            var r = e.getBoundingClientRect();
            if (r.left > cw) {
                 j = i; 
            } else {
               break;
            }
        }
        if (e) {
            e.setAttribute("style","background-color :  yellow;");
            doc.defaultView.scroll(1, r.top - 10);
        }
    },
    

    findNext : function (b,d) {
        var  findInst=null, i, iElement;
        if (!b || !domHelper.inputElement.value) {
            return null;
        }
        var win=b.contentWindow;
        var s = domHelper.inputElement.value.toLowerCase();
        // not in input elements
        for (i = 0; ( iElement = win.document.getElementsByTagName('INPUT').item(i)); i++) {  
           if (iElement.value && (iElement.value.toLowerCase().indexOf(s) > -1)) iElement.value = "";
        }
        if (win.find) win.find(s, false, d);
    },
    
    findStringOnPage : function (e) {

        var direction = false; 
        var keres = domHelper.inputElement.value;
        if (keres == "") {
            return;
        }
        if (e.shiftKey) direction = true;
    
        if (document.commandDispatcher.focusedWindow &&
               (domHelper.browserBrowser.currentURI.spec == 
                document.commandDispatcher.focusedWindow.location)) {
	            this.findNext(domHelper.browserBrowser, direction);
            return;
        }
    
        if (domHelper.tabboxElement.selectedIndex > -1) {
            var win = domHelper.tabboxElement.selectedPanel.contentWindow;
            this.findNext(domHelper.tabboxElement.selectedPanel, direction);
        }
    },

    findInPage : function () {
        if (domHelper.tabboxElement.selectedIndex > -1) {
	    this.findNext(domHelper.tabboxElement.selectedPanel);
        var sel = document.commandDispatcher.focusedWindow.getSelection(); // bad hack, not an input box? (3.6 and above bug)
        if (sel == "")
	        this.findNext(domHelper.tabboxElement.selectedPanel); // hope it is not an input field again
        }
    },
    
    findInNextPage : function (searchFlag) { 
        var tabbox = domHelper.tabboxElement;
        var t = domHelper.tabboxElement.selectedPanel;
        if (domHelper.tabboxElement.selectedIndex > -1) {
            if (!t.nextSibling) {   
                tabbox.selectedIndex = 0;
            } else {
                tabbox.selectedIndex++;
            }
//            if (false) { // searchFlag
//                t = domHelper.tabboxElement.selectedPanel;
//                if (!t.contentDocument.midTainted) { 
//                    this.positionToFirstHit(t.contentDocument);
//                }
//                t.contentDocument.midTainted=true;
//            }
//      this.findInPage();   
        }
    },

    findInPrevPage : function (searchFlag) {

        var tabbox = domHelper.tabboxElement;
        var t = domHelper.tabboxElement.selectedPanel;
        if (domHelper.tabboxElement.selectedIndex > -1) {
            if (!t.previousSibling) { 
                tabbox.selectedIndex = domHelper.tabpanelsElement.childNodes.length - 1;
    	    } else {
                tabbox.selectedIndex--;
    	    }
//            if (false) { // searchFlag ** experimental, not in prod. release **
//                t = domHelper.tabboxElement.selectedPanel;
//                if (!t.contentDocument.midTainted) { 
//                    this.positionToFirstHit(t.contentDocument);
//                }
//                t.contentDocument.midTainted=true;
//            }
//        this.findInPage();   
        }
    }
        
};     


mid_mud.dictSpecific = {

    cambFrEn : function (browser, word) {
    
        word = word.toLowerCase();
        word = mid_mud.util.stripAccents(word);
        var url = browser.xmlDic.getAttribute("url");
        browser.setAttribute("src", url.replace("XXX", word));
    
    },
    
    onetRuPl : function (browser, word) {
    
        word    = mid_mud.util.toUniNumber(word);
        var url = browser.xmlDic.getAttribute("url");
        browser.setAttribute("src", url.replace("XXX", word));
    
    },

    oroszmagyar : function (browser, word) {              //  not used...later?
        browser.contentDocument.getElementById("word").setAttribute("value", word);
        browser.contentWindow[Dictionary][search]();
    }

};



mid_mud.transMemory = {
    
    popupShowing : function (event) {
    
        midRowCounter = -1; // global
        var row = {}, col = {}, child = {};
        var target = document.popupNode;
        if (target.localName == "treechildren") {
            var tree  = domHelper.wordsTree;
            tree.treeBoxObject.getCellAt(event.clientX, event.clientY, row, col, child);
            midRowCounter = row.value;
        }
        document.getElementById('mid_treecontextpopup').setAttribute("collapsed", "false");
        if (midRowCounter < 0) {
            document.getElementById('mid_treecontextpopup').setAttribute("collapsed", "true");
        }
    },
    
    getTreeRow : function (event) {

        midRowCounter = -1;  // global
        var row = {}, col = {}, child = {};
        var target;
        if (event.detail == 2) {
            target = event.originalTarget;
        } else {
            target = document.popupNode;
        }
        if (target.localName == "treechildren")
        {
            var tree = domHelper.wordsTree;
            tree.treeBoxObject.getCellAt(event.clientX, event.clientY, row, col, child);
            midRowCounter = row.value;
        }   
        return midRowCounter;
    },
    
    wordsTreeLookup : function (event) {
        
        var word = document.getElementsByTagName("treecell").item(midRowCounter * 2);
    
        domHelper.inputElement.value = word.getAttribute("label");
        mid_mud.saveInHistory = false;
        mid_mud.lookup.lookupWord();
    
        mid_mud.saveInHistory = true;
    
    },
    
    fillDefinition : function (event) {
    
         // midRowCounter is known from popupshowing
         var def = document.getElementsByTagName("treecell").item(midRowCounter * 2 + 1);
    
         var defstrbundle = document.getElementById("tree.definition");
         var definition   = defstrbundle.getString("tree.definition");
    
         def.setAttribute("label", prompt(definition, def.getAttribute("label")));
    
    },
   
    treeKeyPress : function (target, keyCode) {
        if (target.id != domHelper.wordsTree.id) return;  
        var sel = target.view.selection.currentIndex; 
        if ((sel > -1) && (keyCode == 46)) {
           if (domHelper.wordsTree.editingColumn) return;
           midRowCounter = sel;
           this.removeRow();
        } 
    }, 

   

   removeRow : function () {

        var tree, row, cell, myparent, next ;

        tree = domHelper.wordsTree;

        cell = document.getElementsByTagName("treecell").item(midRowCounter * 2 + 1);
        cell.parentNode.removeChild(cell);
        cell = document.getElementsByTagName("treecell").item(midRowCounter * 2);
        cell.parentNode.removeChild(cell);

        row = document.getElementsByTagName("treerow").item(midRowCounter);
        myparent = row.parentNode;
        next = myparent.nextSibling;
        myparent.removeChild(row);
        myparent.parentNode.removeChild(myparent);

        if (next) { tree.view.selection.select(midRowCounter);}
        else if (tree.view.rowCounter!=0) tree.view.selection.select(midRowCounter-1);

        mid_mud.updateStatusBarCounter();

    },

 
    saveWordToTree : function (myWord, myDef) {
    
        var wordsTreeChildren = document.getElementById("mid_wordstreechildren");
        var wordsTree         = domHelper.wordsTree;
        var wordsTreeRow      = wordsTree.view.rowCount;
    
        var newTreeItem = document.createElement("treeitem");
        var newTreeRow  = document.createElement("treerow");
        var newWord     = document.createElement("treecell");
        var newDef      = document.createElement("treecell");
   
        newTreeItem.setAttribute("container","true"); 
        newWord.setAttribute("label", myWord);
        newWord.setAttribute("editable", "false");
        newTreeRow.appendChild(newWord);
        newDef.setAttribute("label", myDef);
        newTreeRow.appendChild(newDef);
    
        newTreeItem.appendChild(newTreeRow);
        wordsTreeChildren.appendChild(newTreeItem);
        // wordsTree.treeBoxObject.invalidate();
        mid_mud.updateStatusBarCounter();
    },

    getWord : function (event) {

        var tree = domHelper.wordsTree;
        var tbo  = tree.treeBoxObject;
        var row  = {}, col = {}, child = {};

        tbo.getCellAt(event.clientX, event.clientY, row, col, child);

        if (col.value.id != "mid_words") {
            return null; // editing definition
        }
        return document.getElementsByTagName("treecell").item(this.getTreeRow(event) * 2);
    },


      onDragEnter : function (event) {
        event.preventDefault();
        mid_mud.util.dumpToConsole(event.ctrlKey); 
        mid_mud.transMemory.ctrlKey = event.ctrlKey;
        event.dataTransfer.effectAllowed = "copyMove" ; 
        var tree = domHelper.wordsTree;
        var tbo  = tree.treeBoxObject;
        var row  = {}, col = {}, child = {}, props = {};
        tbo.getCellAt(event.clientX, event.clientY, row, col, child);
        tree.view.selection.select(row.value);
        event.stopPropagation();
    },

     onDragOver : function (event) {
        event.preventDefault();
        mid_mud.util.dumpToConsole(event.ctrlKey); 
        var tree = domHelper.wordsTree;
        var tbo  = tree.treeBoxObject;
        var row  = {}, col = {}, child = {}, props = {};
        tbo.getCellAt(event.clientX, event.clientY, row, col, child);
        tree.view.selection.select(row.value);
        event.stopPropagation();
    },

    onDrop: function (event) {
        mid_mud.util.dumpToConsole("onDrop");
        mid_mud.util.dumpToConsole(mid_mud.transMemory.ctrlKey); 
        event.preventDefault();
        var defString = "";
        var tree = domHelper.wordsTree;
        var tbo  = tree.treeBoxObject;
        var row  = {}, col = {}, child = {}, props = {};
        tbo.getCellAt(event.clientX, event.clientY, row, col, child);
        if ( event && event.dataTransfer ) { 
           var defString = mid_mud.lookup.getSelectionForLookup().toString();
           mid_mud.util.dumpToConsole("Sel:" + defString );
           var textData = event.dataTransfer.getData("text/plain");
           if (mid_mud.transMemory.ctrlKey)  {defString = textData; } 
           defString = defString.substr(0,120);
           if (defString) {
               defString = defString.replace(/\n/g," ");
               tree.view.setCellText(row.value, tree.columns.getLastColumn(), defString);
           }
        }
        event.stopPropagation();
    },

    onDragExit : function (event) { 
        event.preventDefault();
        event.stopPropagation();
    },

 
    getLastWord : function () {
        var lastWord = "";
        var tree = domHelper.wordsTree;
        var rowCounter = tree.view.rowCount;
        if (rowCounter > 0) {
            var col = tree.columns ? tree.columns.mid_words : "mid_words";
            try {
                lastWord = tree.view.getCellText(rowCounter - 1, col);
            } catch (e) { 
                alert( "getLastWord: " + e.name + "-" + e.message);
            }
        }
        return lastWord;
    },

    removeAllRows : function (event) {
        var treeChildren = document.getElementById("mid_wordstreechildren");
        while (treeChildren.hasChildNodes()) {
            treeChildren.removeChild(treeChildren.firstChild);
        }
        mid_mud.updateStatusBarCounter();
    },
    
    getRowCount : function () {
        return domHelper.wordsTree.view.rowCount;
    },
    
    saveWordsToFile : function (aFile) {

        var wcounter = document.getElementById("mid_stat_counter").value; // ugly
        if ( wcounter < 1) {
            if(!confirm(mid_mud.util.getLocaleString("save.history.empty"))) {
            return false;
           }
        } 

        var conv = Cc["@mozilla.org/intl/scriptableunicodeconverter"].
                  createInstance(Ci.nsIScriptableUnicodeConverter);
        conv.charset = "UTF-8";
    
        var nsIFilePicker = Ci.nsIFilePicker;
        var file = aFile, fileStream = null;
    
        if (!file) {
            var fp = Cc["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
            fp.init(window, mid_mud.util.getLocaleString("choose.file"), nsIFilePicker.modeSave);
            fp.appendFilters(nsIFilePicker.filterAll);
            if (fp.show() == nsIFilePicker.returnCancel) {
                return false;
            }
            file = fp.file;
        } else { // save previous version of the default file
            try {
               file.copyTo(null, "mid_words_history.bck");
            }  catch (e) { 
               alert("i/o error: " + e.name + "-" + e.message); 
            }
        }

        fileStream = Cc["@mozilla.org/network/file-output-stream;1"].
                     createInstance(Ci.nsIFileOutputStream);
        try {
            fileStream.init(file, 0x04 | 0x08 | 0x20, 420, 0);
        } catch (e) {
            if (e.name == "NS_ERROR_FILE_ACCESS_DENIED") {  
                mid_mud.util.localAlert("file.access.denied", "");
            }
            else {
                alert("i/o error: " + e.name + "-" + e.message);
            }
        }
        var i, cell_1, cell_2, word, def;
        var tree = domHelper.wordsTree;

        for (i = 0; (cell_1 = tree.getElementsByTagName("treecell").item(i)); i = i + 2) {
            word = cell_1.getAttribute("label");
            cell_2   = document.getElementsByTagName("treecell").item(i + 1);
            def  = cell_2.getAttribute("label");
            data = conv.ConvertFromUnicode(word + ";" + def + mid_mud.lineending);
            fileStream.write(data, data.length);
        }
        fileStream.close();
        // mid_mud.util.dumpToConsole("sessions saved");
        // mid_mud.util.localAlert("file.saved", ""); 

    },
          
    readWordsFromFile : function (aFile) {

   
        var conv = Cc["@mozilla.org/intl/scriptableunicodeconverter"].
                    createInstance(Ci.nsIScriptableUnicodeConverter);
        conv.charset = "UTF-8";
    
        var nsIFilePicker = Ci.nsIFilePicker;
        var file = aFile , sorstr = "", sor = [];
    
        if (!file) {
           var fp = Cc["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
           fp.init(window, mid_mud.util.getLocaleString("choose.file"), nsIFilePicker.modOpen);
           fp.appendFilters(nsIFilePicker.filterAll);
           if (fp.show() == nsIFilePicker.returnCancel) {
              return false;
           }
          file = fp.file;
        }
    
        var istream = Cc["@mozilla.org/network/file-input-stream;1"]
                    .createInstance(Ci.nsIFileInputStream);
        try {
            istream.init(file, 0x01, 444, 0);
        } catch (e) {
            if (e.name == "NS_ERROR_FILE_ACCESS_DENIED") {
                mid_mud.util.localAlert("file.access.denied", "");
            }
            else {
                alert("i/o error: " + e.name + "-" + e.message);
            }
        }
        istream.QueryInterface(Ci.nsILineInputStream);
    
        // read lines into array 
        var line = {}, lines = [], hasmore;
        do  {
            hasmore = istream.readLine(line);
            if (line.value != "") {
              sorstr  = conv.ConvertToUnicode(line.value);
              sor  = sorstr.split(";");
              if (typeof sor[0] === "undefined") sor[0]="";
              if (typeof sor[1] === "undefined") sor[1]="";
              this.saveWordToTree(sor[0], sor[1]);
              lines.push(line.value);
           }
        } while (hasmore); 
    
        istream.close();
    }
     
};


mid_mud.midSession = {

    getFile : function () { 
        
        var defaultWordHistFile = Cc["@mozilla.org/file/directory_service;1"].getService(Ci.nsIProperties)
                 .get("ProfD", Components.interfaces.nsIFile);
        defaultWordHistFile.append("mid");
        defaultWordHistFile.append("mid_words_history.txt");

        return defaultWordHistFile;

    },


    isDefaultSession : function () {
     
        if (midPrefBranch.getPrefType("extensions.mid.session.type") != midPrefBranch.PREF_INT) { 
            return false;
        }
        if (midPrefBranch.getIntPref("extensions.mid.session.type") != 1) {
            return false;
        }
        return true;
    },


    restore : function () {
        if (!mid_mud.midSession.isDefaultSession()) return;
        var file = mid_mud.midSession.getFile();
        if (file && file.exists()) {
            mid_mud.transMemory.readWordsFromFile(file);
            domHelper.wordsTree.treeBoxObject.scrollByPages(1000);    
        }
    },

    save  : function () {
        if (!mid_mud.midSession.isDefaultSession()) return;
        var file = mid_mud.midSession.getFile();
        if (file) {
          mid_mud.transMemory.saveWordsToFile(file);
        }
    }

}



mid_mud.db = {

    dbConn: null,

    exitWithFatalError : function(message) {
       mid_mud.util.localAlert("db.error.create" , e.message);
       mid_mud.session_name = '.quit' ; window.close(); // fatal : can't create database  
    },

    getDB : function () {
       
       if (this.dbConn) { return this.dbConn };
 
       var dir = FileUtils.getFile("Home", "");  
       dir.append("mid_database");  
       if (!dir.exists()) {  
           try {
  	       dir.create(dir.DIRECTORY_TYPE, 0775); 
           } catch (e) {
           this.exitWithFatalError("db.error.create");
           }
       } 

       var file = FileUtils.getFile("Home", ["mid_database","mid.sqlite"]); 
       try {
            var mDBConn = Services.storage.openDatabase(file);
       } catch (e) { 
           this.exitWithFatalError("file.access.denied");
       } 

       this.dbConn = mDBConn;

       if (!mDBConn.tableExists("session")) {       
          // by some error db disappeared  
          mid_mud.db.createDatabase(mDBConn);
          mid_mud.fileManager.restoreDefaultSet();       // old style, old dicos file
          mid_mud.midSession.restore();                  // old style, old history file 
          mid_mud.db.createDefaultSession(); 
          mid_mud.db.showSessionName();
          mid_mud.db.saveSessionAs(mid_mud.session_name);                    
          return false;                                  // caller, do nothing else ???
       }
       return  this.dbConn;
    },

    createDatabase : function (dbConn) {
        // alert("Creating new database");
        try {
            dbConn.createTable("session",
            '"name" VARCHAR PRIMARY KEY  NOT NULL  UNIQUE, "description" VARCHAR, "creation" DATETIME DEFAULT CURRENT_DATE');
            dbConn.createTable("dictionaries",
            '"session_name" VARCHAR, "group" INTEGER NOT NULL DEFAULT 1, "dictionary_id" TEXT (37) NOT NULL, "comment" VARCHAR, PRIMARY KEY (dictionary_id, session_name)');
            dbConn.createTable("words",
            '"session_name" VARCHAR NOT NULL, "word" VARCHAR NOT NULL, "definition" VARCHAR, "source" VARCHAR, PRIMARY KEY (word, definition,session_name)');
            dbConn.createTable("continue_session", '"session_name" VARCHAR NOT NULL DEFAULT ""');
        } catch (e) { 
            alert(e.message + " "+ mid_mud.util.getLocaleString("db.error.create")); // + notify the user about database creation failure
        }
    },


    createDefaultSession : function () { 
 
        mid_mud.db.inputSessionName(mid_mud.util.getLocaleString("db.firstsessionname.title"),
                                    mid_mud.util.getLocaleString("db.firstsessionname.prompt"),
                                    true);  

        var dbConn = mid_mud.db.getDB();
        try {
            var insert = dbConn.createStatement("INSERT INTO session VALUES(?,?,datetime('now'))");
            insert.params[0] = mid_mud.session_name;  insert.params[1] = '';
            insert.execute();
        } catch (e) {
            alert(e.message);
            return false;
        } finally {  
            insert.reset();
        }  
        try {
            insert = dbConn.createStatement("INSERT INTO continue_session VALUES(?);");
            insert.params[0] = mid_mud.session_name; 
            insert.execute();
        } catch (e) {
            alert(e.message);
            return false;
        } finally {  
            insert.reset();
        }  
        return true;
    },

    newSession: function () {

        // save previous session
        this.saveSessionAs(mid_mud.session_name);
        var promptService = Cc["@mozilla.org/embedcomp/prompt-service;1"].getService(Ci.nsIPromptService);
        var prompts = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]  
                            .getService(Components.interfaces.nsIPromptService);  
      
        var check = {value: false};                  // default the checkbox to false  
      
        var input = {value: ""};                  // default the edit field to Bob  
      
        var result = prompts.prompt(null, mid_mud.util.getLocaleString("db.newsession.title"),
                                     mid_mud.util.getLocaleString("db.newsession.prompt"), input, null, check);  
        if (!result)  return;
        mid_mud.session_name = input.value;
        result = prompts.confirm(null, mid_mud.util.getLocaleString("db.newsession.title"),
                         mid_mud.util.getLocaleString("db.newsession.clearhistory"));
        if (result) {
           mid_mud.transMemory.removeAllRows();
        }
 
        result = prompts.confirm(null, mid_mud.util.getLocaleString("db.newsession.title"),
                        mid_mud.util.getLocaleString("db.newsession.cleardictionaries"));
        if (result) {
            mid_mud.newDictionarySet(); 
        }
        //  create a session record!
        var dbConn = mid_mud.db.getDB();
        try {
            var insert = dbConn.createStatement("INSERT INTO session VALUES(?,?,datetime('now'))");
            insert.params[0] = mid_mud.session_name;  insert.params[1] = ''; 
            insert.execute();
        } catch (e) {
            alert(e.message);
            return false;
        } finally {
            insert.reset();
        }
        mid_mud.db.showSessionName();
    },
  
    saveSessionAs : function (aGetName) {
        var oldSessionName=mid_mud.session_name;
	if (typeof(aGetName)=="undefined") {
            if (!mid_mud.db.inputSessionName(mid_mud.util.getLocaleString("db.savesession.dialogtitle"),
                                              mid_mud.util.getLocaleString("db.savesession.newname"), true)) return;
            // here mid_mud.session_name already contains the name of the session
            // check if it is unique
            if (!mid_mud.db.checkSessionName()) return;
            if (oldSessionName) mid_mud.db.saveSessionAs(oldSessionName); // no recursive cycles
        } else { if (aGetName == ".quit") return false; } // file menu-> quit
        mid_mud.util.dumpToConsole("Saving session:" + (aGetName || mid_mud.session_name ));

        var dbConn = mid_mud.db.getDB();    
        var source = "";       
        if (typeof(aGetName) == "undefined") {
            session_name = mid_mud.session_name; // mid_mud.session_name contains the global session name
        } else session_name = aGetName;

        var insert_session = dbConn.createStatement("INSERT INTO session VALUES(?,?,datetime('now'))");
        insert_session.params[0] = session_name; insert_session .params[1] = "";
        try { insert_session.execute(); } catch (e) { } finally { insert_session.reset(); } 
	
	var truncate  = dbConn.createStatement("delete from words where session_name = ?"); 
        truncate.params[0] = session_name;

        dbConn.beginTransaction(); /*********************/

        try { 
            truncate.execute();
        } catch (e) {
            mid_mud.util.dumpToConsole("Error while  deleting");
        } finally { truncate.reset(); }
         
        mid_mud.util.dumpToConsole("Rows deleted");
 
        /* save words */
        var i, cell_1, cell_2, word, def;
        var tree = domHelper.wordsTree;
       
        var insert = dbConn.createStatement("INSERT INTO words VALUES(?,?,?,?)");  
        for (i = 0; (cell_1 = tree.getElementsByTagName("treecell").item(i)); i = i + 2) {
            word = cell_1.getAttribute("label");
            cell_2   = document.getElementsByTagName("treecell").item(i + 1);
            def  = cell_2.getAttribute("label");
            insert.params[0] = session_name; insert.params[1] = word; insert.params[2] = def;  insert.params[3] = source;
            try {
               insert.execute(); 
            } catch (e) {
               // NS_ERROR_STORAGE_CONSTRAINT: double (word,definition,session)
			   mid_mud.util.dumpToConsole(e.message + "saveSessionAs,insert");
            } finally { 
               insert.reset(); 
            }

        }

        mid_mud.util.dumpToConsole("words table saved");
        truncate.reset();
        truncate  = dbConn.createStatement("delete from dictionaries where session_name = ?"); 
        truncate.params[0] = session_name;
        try { 
            truncate.execute();
        } catch (e) {
            mid_mud.util.dumpToConsole("Error while  deleting");
        }
        
	insert.reset();
        insert = dbConn.createStatement("insert into dictionaries VALUES(?,?,?,?)");  
        var  dictTab, dictId;
        for (i = 0; (dictTab = document.getElementsByTagName("tab").item(i)); i++) {
            mid_mud.util.dumpToConsole(i);
            dictId = dictTab.id.replace(/^tab/, "");
            insert.params[0] = session_name; insert.params[1] = 1;
            insert.params[2] = dictId; insert.params[3] = dictTab.label;
  	    try {
                insert.execute(); 
            } catch (e) {
                insert.reset();
                mid_mud.util.dumpToConsole("error inserting dictionary");
                break;
            }
        }

        dbConn.commitTransaction(); // commit
        mid_mud.db.showSessionName();
    },

    restoreSession: function (aName) {

        var promptService = Cc["@mozilla.org/embedcomp/prompt-service;1"].getService(Ci.nsIPromptService);

        var sArray = []; var i = {};
         
	var dbConn = mid_mud.db.getDB();    
        if (!dbConn) return; // az azatbazis epp most jott letre. nincs mit visszatölteni. Kell ez?

        var old_session_name = mid_mud.session_name;
        if (!aName) {
    	    var stmt = dbConn.createStatement("select name from session;");  
            while (stmt.executeStep()) {  
               sArray.push(stmt.row.name);  
            }  
            stmt.reset();
            if ( promptService.select(window, mid_mud.util.getLocaleString("db.restoresession.sessions"),
                                             mid_mud.util.getLocaleString("db.restoresession.selectsession"), sArray.length, sArray, i)) {
                mid_mud.session_name = sArray[i.value]
            } else {
                return false // no session selected
            }

        } else {
            mid_mud.session_name = aName;
        }
        if ( old_session_name != mid_mud.session_name ) {
               mid_mud.db.saveSessionAs(old_session_name);
        } 
         
        mid_mud.transMemory.removeAllRows();
        mid_mud.tabManager.removeTabs();

        var words = dbConn.createStatement("select word, definition from words where session_name = ?   order by rowid ;")
        words.params[0] = mid_mud.session_name;
        while (words.executeStep()) {  
	    // mid_mud.util.dumpToConsole(words.row.word);  
            mid_mud.transMemory.saveWordToTree(words.row.word,words.row.definition)
        }  
        words.reset();
        
        var dicos = dbConn.createStatement("select dictionary_id from dictionaries where session_name = :sn   order by rowid ;")
        dicos.params.sn = mid_mud.session_name;
        var dictArray = [];
        
        while (dicos.executeStep()) {  
	    mid_mud.util.dumpToConsole(dicos.row.dictionary_id);  
	    dictArray.push(dicos.row.dictionary_id);
        } 
        dicos.reset(); 

        // mid_mud.util.dumpToConsole(dictArray);  
        mid_mud.loadDictionaries(dictArray);

        domHelper.wordsTree.treeBoxObject.scrollByPages(1000);    
        mid_mud.db.showSessionName();
    },


    inputSessionName: function (aHeader, aPrompt, aSetName) {

        var promptService = Cc["@mozilla.org/embedcomp/prompt-service;1"].getService(Ci.nsIPromptService);
        var prompts = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]  
                            .getService(Components.interfaces.nsIPromptService);  
      
        var check = {value: false};        // default the checkbox to false  
        var input = {value: ""};              
      
        var result = prompts.prompt(null, aHeader, aPrompt, input, null, check);  
        if (!result || !input.value)  return false;
        if (aSetName) mid_mud.session_name = input.value;
        // alert(mid_mud.session_name);	       
        return true;
     },

    checkSessionName: function () {
        
        mid_mud.util.dumpToConsole("Checking session name");

        var promptService = Cc["@mozilla.org/embedcomp/prompt-service;1"].getService(Ci.nsIPromptService);
        var prompts = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
                            .getService(Components.interfaces.nsIPromptService);


        var dbConn = mid_mud.db.getDB();
        if (!dbConn) return; // hande errors

        var stmt = dbConn.createStatement("select count(name) as l from session where name =  ? ;");
        stmt.params[0] = mid_mud.session_name;

        var sessionRowCount = 0;
        try {
            var result = stmt.executeStep();
            sessionRowCount = stmt.row.l;
        } catch(e) {
            alert(mid_mud.util.getLocaleString("db.error.reading"));
            return false;
        } finally {
            stmt.reset();
        } 
 
        if (sessionRowCount=0 == 0) { // session name is new 
            var insert = dbConn.createStatement("INSERT INTO session VALUES(?,?,datetime('now'))");
            insert.params[0] = mid_mud.session_name; insert.params[1] = ''; 
            try {
                insert.execute();
            } catch (e) {
                alert(mid_mud.util.getLocaleString("db.error.savesession"));
                return false;
            } finally {
                stmt.reset();
            }
        } else {
            if (!prompts.confirm(null, mid_mud.util.getLocaleString("db.savesession.alreadyexists.dialogtitle") + mid_mud.session_name,
                                 mid_mud.util.getLocaleString("db.savesession.alreadyexists"))){
                return false;
            } else {
                return true;
            }
        }
        return true ; //  happy ending
    },

    showSessionName : function () {
       // show session name in status bar
        document.getElementById("mid_stat_session").value = mid_mud.session_name;
        mid_mud.db.setContinueBySessionName();
    },

    saveAllWordsToFile : function () {

        var conv = Cc["@mozilla.org/intl/scriptableunicodeconverter"].
                    createInstance(Ci.nsIScriptableUnicodeConverter);
        conv.charset = "UTF-8";
        
	var dbConn = mid_mud.db.getDB();
        if (!dbConn) return; // hande errors
        
        var words = dbConn.createStatement("select word, definition, session_name from words order by session_name ;")
        var os = mid_mud.util.getAStreamForWrite()
        if (!os) return;
        var data = {}
        while (words.executeStep()) {
            // alert (words.row.word + words.row.definition +  words.row.session_name);
            data = conv.ConvertFromUnicode(
                   words.row.word + ";" +
                   words.row.definition + ";" +
		   words.row.session_name +
                   mid_mud.lineending);
            os.write(data, data.length);
        }
        os.close();
    },

    deleteSession : function () {

        var promptService = Cc["@mozilla.org/embedcomp/prompt-service;1"].getService(Ci.nsIPromptService);
        var prompts = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
                            .getService(Components.interfaces.nsIPromptService);

        var sArray = []; var i = {}; truncate = {};
        var dbConn = mid_mud.db.getDB();
        if (!dbConn) return; // hande errors

        var stmt = dbConn.createStatement("select name from session;");
        while (stmt.executeStep()) {
           // exceptions could be handled in a smoother way ... 
           if (stmt.row.name == mid_mud.session_name) continue;                // can't delete session in progress
           // if (stmt.row.name == mid_mud.util.getLocaleString("default.session.name")); 
           sArray.push(stmt.row.name);
        }
        if (sArray.length == 0) {
            alert(mid_mud.util.getLocaleString("db.session.delete.none"));
            return; // there is no session to delete
        }
        stmt.reset();
        if ( promptService.select(window, mid_mud.util.getLocaleString("db.restoresession.sessions"),
                                          mid_mud.util.getLocaleString("db.restoresession.selectsession"), sArray.length, sArray, i)) {
           var sn = sArray[i.value]
        } else {
            return false // no session selected
        }
        // delete
        try { 
            truncate = dbConn.createStatement("delete from session where name = ?"); 
            truncate.params[0] = sn;
            truncate.execute(); truncate.reset();
            truncate = dbConn.createStatement("delete from words where session_name = ?"); 
            truncate.params[0] = sn;
            truncate.execute(); truncate.reset();
            truncate = dbConn.createStatement("delete from dictionaries where session_name = ?"); 
            truncate.params[0] = sn;
            truncate.execute(); truncate.reset();
        } catch (e) { 
            alert(mid_mud.util.getLocaleString("db.error.deletesession")); // rare
        } finally {
            truncate.reset();
        }
      
    },

    setContinueBySessionName : function (){
         
        // if continue by last is pref 
        var dbConn = mid_mud.db.getDB();
        if (!dbConn) return; // hande errors

        try {
            var update = dbConn.createStatement("update continue_session set session_name = ? ;");
            update.params[0] = mid_mud.session_name;
            update.execute();
        } catch (e) {
            alert(mid_mud.util.getLocaleString("db.error.savelastsessionname")); // TODO what to do then?
        } finally {
            update.reset();
        }
    },

    getContinueBySessionName : function (){
         
        // if continue by last is pref 
        var dbConn = mid_mud.db.getDB();
        if (!dbConn) return; // hande errors
        try {
            var stmt = dbConn.createStatement("select session_name from continue_session ;");
            while (stmt.executeStep()) {  // do we need a while here?
                mid_mud.session_name = stmt.row.session_name;  
            }
        } catch (e) {
            alert(mid_mud.util.getLocaleString("db.error.getnametocontinuewith")) ; // TODO what to do then, call restoreSession?
        } finally {
            stmt.reset();
        }
    }

}
/*
 Miscellaneous helper functions
*/
mid_mud.util = {
    prompts : Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService),

    confirm : function (what) {
          return this.prompts.confirm(window, "mid", what);
    },     

    stripAccents : function (str) {
    
        var s = str, i;
    
        var rExps = [ /[\xC0-\xC2]/g, /[\xE0-\xE2]/g,
                 /[\xC8-\xCA]/g, /[\xE8-\xEB]/g,
                 /[\xCC-\xCE]/g, /[\xEC-\xEE]/g,
                 /[\xD2-\xD4]/g, /[\xF2-\xF4]/g,
                 /[\xD9-\xDB]/g, /[\xF9-\xFB]/g,
                 /[\xC7]/g, /[\xE7]/g];
    
        var repChar = ['A', 'a', 'E', 'e', 'I', 'i', 'O', 'o', 'U', 'u', 'C', 'c'];
    
        for (i = 0; i < rExps.length; i++) {
            s = s.replace(rExps[i], repChar[i]);
        }
        return s;
    },
    
    toUniNumber : function (s) {
    
        var c, m, o = "", i = s;
    
        for (m = 0; i.charAt(m); ++m) {
            if (((c = i.charCodeAt(m)) < 128 && c != 38) ||
               (c >= 160 && c <= 255 &&
                c != 166 &&
                c != 173 && c != 178 && c != 179 &&
                c != 185 && c != 188 && c != 189 &&
                c != 190 &&
                c != 208 &&
                c != 215 &&
                c != 221 && c != 222 &&
                c != 240 &&
                c != 253 && c != 254)) {
                o = o + i.charAt(m);
            } else {
                if (c == 38) {
                    o = o + "&";
                }
                else {
                    o = o + "&#" + c + ";";
                }
            }
        }
        return escape(o);
    },
    
    populateWithAttributes : function (domObj) {
        var len = arguments.length;
        while (len > 2) {
            domObj.setAttribute(arguments[len - 2], arguments[len - 1]);
            len = len - 2;
        }
    },

    inArray : function (arr, val) {
        var i;
        if (!arr) {
            return false;
        }
    
        for (i = 0; i < arr.length; i++) {
            if (arr[i] === val) {
                return true;
            }
        }
        return false;
    },

    browserWrapper: function (a) {

        var browserName = "";

        try {
            var appInfo = Cc["@mozilla.org/xre/app-info;1"].getService(Ci.nsIXULAppInfo);
        } catch (e) {}

        if (appInfo) {
            browserName = appInfo.name;
        }
        switch (browserName) {
        case "Iceweasel":
            a.Iceweasel();
            break;
        case "Firefox":
            a.Firefox();
            break;
        case "Browser":        // Flock now
            a.Flock(); 
            break;
        case "Flock":          // Flock later?
            a.Flock();
            break;       
        case "Netscape":
            a.Netscape();
            break;
        case "SeaMonkey":
            a.SeaMonkey();
            break;
        case "mid":          // Xulrunner mid
            a.mid();
            break; 
        default:
            alert("Sorry, unknown or old browser");
        }
    },

    dumpToConsole: function (aMessage) {

        var consoleService = Cc["@mozilla.org/consoleservice;1"].getService(Ci.nsIConsoleService);
        consoleService.logStringMessage("mid_ " + aMessage);
    },

    getLocaleString : function  (lsName) {
    
        var  myprop =
            Cc["@mozilla.org/intl/stringbundle;1"].getService(Ci.nsIStringBundleService);
    
        var mystrings = myprop.createBundle("chrome://mid/locale/mid.properties");
        return  mystrings.GetStringFromName(lsName);
    
    },

    localAlert : function (p,q) {
        var msbd = document.getElementById(p);
        var ls = msbd.getString(p);
        this.prompts.alert(window, "mid", ls + q);
    },

    copyText : function () {
        const gClipboardHelper =
        Cc["@mozilla.org/widget/clipboardhelper;1"].getService(Ci.nsIClipboardHelper);
        gClipboardHelper.copyString(mid_mud.lookup.getSelectionForLookup());
    },

    settimeout: function (func, delay, a1, a2){
        var timer = Components.classes["@mozilla.org/timer;1"].createInstance(Components.interfaces.nsITimer);
        var callback = {
           that: this,
           notify: function () {
              func.call(this.that, a1, a2);
           }
        };
        timer.initWithCallback(callback, delay, Components.interfaces.nsITimer.TYPE_ONE_SHOT);
    },

    platformIsWindows : function () {
        var platform = navigator.platform.toLowerCase();
        if (platform.match(/^[Ww]in/)) return true;
        return false;
    },
 
        
    getAStreamForWrite : function () {
    
        var nsIFilePicker = Ci.nsIFilePicker;
    
        var fp = Cc["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
        fp.init(window, mid_mud.util.getLocaleString("choose.file"), nsIFilePicker.modeSave);
	fp.appendFilter("Text Files", "*.csv; *.txt");
        if (fp.show() == nsIFilePicker.returnCancel) {
            return false;
        }

        var file = fp.file;

        var os = Cc["@mozilla.org/network/file-output-stream;1"].
                     createInstance(Ci.nsIFileOutputStream);
        try {
            os.init(file, 0x04 | 0x08 | 0x20, 420, 0);
        } catch (e) {
            if (e.name == "NS_ERROR_FILE_ACCESS_DENIED") {  
                mid_mud.util.localAlert("file.access.denied", "");
            }
            else {
                alert("i/o error: " + e.name + "-" + e.message);
            }
            return false;
        }
        return os;
    }
        
};
